/************************************************************* 2006.1.2 ******/
//  forcedvib21.c : QRxŨV~[V                       //
//                  P}Xɋ͐U                                     //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          501
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

static double mass1, lamda1, Kspring1;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double mass2, lamda2, Kspring2;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double a, t, dt=0.01;
static int    nrkg=4;                //nrkg*dtɃf[^擾
static double om1, zeta1;            //ŗLU((K1+K2)/m1(rad/s))C
static double om2, zeta2;            //ŗLU(k2/m2)(rad/s))C
static double om12, zeta12;          //ŗLU(k2/m1(rad/s))C
static double om01, om02;             //ŗLU01,02
static double zeta01, zeta02, zeta012, lmd2; //̒lێ
static double p2, p12;               //U(2/1), (12/1)
static double Force, omf, Yf;        //P}XUU(m)CU(rad/s)
static double z, dz, zz;             //U z=f/1
static double Amps, Ampd, fai;       //Ý(m)CU(m)Cʑx(rad)
static double Amp1[2], Amp2[2];      //O͐UƂ̂Ƃ̒U1,2(m)
static double Ym[2][2];              //QÛƂ̂Q}XU
static double Ya[2];                 //ÛƂ̂Q}XU
static double yy0[2], vv0[2], yy1[4], yy2[4], yseries[3][MMAX];
static double yfig[2];               //}X`悷UU
static double aseries1[10][MMAX], aseries2[10][MMAX]; //2ςg
static double aseriesp1[MMAX], aseriesp2[MMAX]; //ݒ肵n̎g
static int    mf, nf;                //g̉ݐCȐ
static double wt, wy[3];             //ψʁExȐ̎ԍ݂Əc{
static double wf, wa[10], wph[10];   //nf{̎gȐ̏c{
static double arrow0[2], arrowl, alpha, arrowd;
static double r0[2], rc[2], rf1[2], rf2[2], r1[2]; //`e_
static double limit;                 //flimitȏ̐U͕`悵Ȃ
//static double transx, transy, rot;
static int    m, n;
static int    MotionSign;
unsigned char KEY;
void   rkg();
void drawfigure2();
void drawcurve1limit();
void drawcurvenlimit();
void dialogue();
//double xedge=0.99;

/************** ̉ *********************************************/
double f(int i, double t, double y[])
{
	static double yd, yv, yy;

	if(i==0) yy = y[1];
	if(i==2) yy = y[3];
    if(i==1) yy = (Force*sin(omf*t) - lamda1*y[1] - lamda2*(y[1]-y[3])
		         - Kspring1*y[0] - Kspring2*(y[0]-y[2]) )/mass1;
	if(i==3) yy = -(lamda2*(y[3]-y[1]) + Kspring2*(y[2]-y[0]) )/mass2;
	return yy;
}
/************* f() end *******************************************************/

/************** ǧvZ **********************************************/
//     z=f/1ɑ΂}XPCQ̐UAmp[0,1]vZ                        //
/******************************************************************************/
void f_a_relation21(double z, double Amp[])
{
	static double zz, A1, B1, A2, B2, A12, B12, A21, B21, delta;
	static double DR, DI;

	zz  = z*z;
	A1  = 1 - zz;	    B1  = 2*zeta1*z;
	A12 = p12*p12;	    B12 = 2*zeta12*p12*z;
	A21 = p2*p2;	    B21 = 2*zeta2*p2*z;
	A2  = p2*p2 - zz;	B2  = 2*zeta2*p2*z;
	DR  = (A1*A2 - B1*B2) - (A12*A21 - B12*B21);
	DI  = (A1*B2 + A2*B1) - (A12*B21 + A21*B12);
	delta = DR*DR + DI*DI;
	Amp[0] = (1 - p12*p12)*sqrt( (A2*A2 + B2*B2)/delta );
	Amp[1] = (1 - p12*p12)*sqrt( (A12*A12 + B12*B12)/delta );
}
/******** f_a_relation21() end **************************************************/

/************************************************************************************/
int main(int argc, char *argv[])
{
	KEY = 'm';
	dialogue();
	DrawGL(&argc, argv);
}
/****************** main() end **************************************************/
/*********** dialogue() *****************************************************/
void dialogue(void)
{
	static int  i, k;
	static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};
	static double D, aa[2];

	if(KEY=='m')  goto d1;     //n̒萔ݒ
	if(KEY=='g')  goto d2;     //O͏ݒ
	if(KEY=='j')  goto d3;     //ݒ

d1:
	//--------------- n̒萔ݒ -----------------------------------------------//
	printf("\n΂ˁ[}X[΂ˁ[}X");
	printf("\nm1*ddy1/ddt + 1*dy1/dt + K1*y1 + 2*(dy1/dt-dy2/dt) + K2*(y1-y2) = yf");
	printf("\nm2*ddy2/ddt + 2*(dy1/dt-dy2/dt) + K2*(y1-y2) = 0");
	printf("\nyf=F*sin(f*t) \n");

	printf("\n(1) n̒萔ݒ"); 
	printf("\n(2) O͏ݒ"); 
	printf("\n(3) ݒ\n"); 

	printf("\n(1-1) }Xm1[kg]C_p[1[N/(m/s)]C΂˒萔K1[N/m]");
	printf("\n      L[́@m1 1 K1=  ");
	scanf("%lf %lf %lf", &mass1, &lamda1, &Kspring1);
	printf("(1-2) }Xm2[kg]C_p[2[N/(m/s)]C΂˒萔K2[N/m]@L[");
	printf("\n      L[  m2 2 K2=  ");
	scanf("%lf %lf %lf", &mass2, &lamda2, &Kspring2);
    om1   = sqrt( (Kspring1+Kspring2)/mass1 );
	zeta1 = (lamda1+lamda2)/(2*mass1*om1);
    om2   = sqrt(Kspring2/mass2);
	zeta2 = lamda2/(2*mass2*om2);
    om12  = sqrt(Kspring2/mass1);
	zeta12= lamda2/(2*mass1*om12);
	p2    = om2/om1;
	p12   = om12/om1;
	D     = sqrt( (1+p2*p2)*(1+p2*p2) - 4*p2*p2*(1-p12*p12) );
	om01  = 0.5*(1+p2*p2 - D);
	om02  = 0.5*(1+p2*p2 + D);
	om01 = sqrt(om01)*om1;              //ŗLU1
	om02 = sqrt(om02)*om1;              //ŗLU2
	f_a_relation21(om01/om1, aa);    Ym[0][0] = aa[0];  Ym[0][1] = aa[1]; //UU1    
	f_a_relation21(om02/om1, aa);    Ym[1][0] = aa[0];  Ym[1][1] = aa[1]; //UU2
	f_a_relation21(om2/om1, aa);     Ya[0] = aa[0];     Ya[1] = aa[1];    //UU

	printf("\n1=(K1+K2)/m1=%7.4f[rad/s],  1=(1+2)/(2*m1*1)=%7.4f",om1,zeta1);
	printf("\n2 =  K2/m2  =%7.4f[rad/s],  2=    2/(2*m2*2)  =%7.4f",om2,zeta2);
	printf("\n12=  K2/m1  =%7.4f[rad/s],  12=   2/(2*m1*12) =%7.4f",om12,zeta12);
	//------------ ݒ肵n̎gvZ -------------------------------//
    dz = 0.02;  mf = 300;
	for(k=0;k<=mf;k++)
	{    z = k*dz;
	     f_a_relation21(z, aa);
		 aseriesp1[k] = aa[0];
		 aseriesp2[k] = aa[1];
	}
	//------------ QςgvZ -------------------------//
	nf = 9;
	zeta01 = zeta1;	 zeta02 = zeta2;	zeta012 = zeta12;
	for(i=0;i<nf;i++)
	{
		zeta2 = zeta0[i];
		lmd2 = 2*zeta2*mass2*om2;
		zeta1 = (lamda1 + lmd2)/mass1/2;
		zeta1 = lmd2/mass1/2;
		for(k=0;k<=mf;k++)
		{    z = k*dz;
		     f_a_relation21(z, aa);
			 aseries1[i][k] = aa[0];
			 aseries2[i][k] = aa[1];
		}
	}
	zeta1 = zeta01;	 zeta2 = zeta02;	zeta12 = zeta012;

d2:
	//------------ O͏ -----------------------------------//
	printf("\nŗLU 0[1,2]     =(%7.4f  %7.4f)[rad/s]", om01,om02);
    printf("\nPÛQ}XU Ym1=(%7.4f %7.4f)[m](K)",Ym[0][0],Ym[0][1]);
    printf("\nQÛQ}XU Ym2=(%7.4f %7.4f)[m](K)",Ym[1][0],Ym[1][1]);
	printf("\nUU  2       = %7.4f[rad/s]", om2);
    printf("\nÛQ}XU   Ya =(%7.4f %7.4f)[m](K)",Ya[0],Ya[1]);
	printf("\n}XQň    2 =2/(2*m2*2)=%7.4f",zeta2);
	printf("\n\n(2) O͐UUF=K1*(1m)=%6.3f[N]CUf[rad/s]@L[ f=",Kspring1);
	scanf("%lf",&omf);
	z = omf/om1;
	Yf = 1;   Force = Kspring1*Yf;
    f_a_relation21(z, aa);
	//--------- ݒ肵O͐ÛƂ̃}X1,2̐UU ------//
	Amp1[0] = z;   Amp1[1] = aa[0];
	Amp2[0] = z;   Amp2[1] = aa[1];
d3:
	printf("\nO͐UUFf=%7.4f[N], ÝYf=%7.4f[m]",Force,Yf);
	printf("\nUUA1=%7.4f[m]        A2=%7.4f[m]",aa[0]*Yf,aa[1]*Yf);
	//-----------------  -----------------------------//
	printf("\n(3) L[́@y01 v01 y02 v02= ");
	scanf("%lf %lf %lf %lf",&yy0[0], &vv0[0],&yy0[1],&vv0[1]);
	printf("\n\n's'L[ŁFU`p         'T' 't'L[ŁFԎgk");
	printf("\n'm'L[ŁF΂˃}X萔ύX     'Y' 'y'L[ŁFUȐEgcgk");
	printf("\n'g'L[ŁFO͏ύX         'X' 'x'L[ŁFggk");
	printf("\n'j'L[ŁFύX");
	printf("\n'f'L[ŁFg`");
	printf("\n'f'L[ŁFg`");
	printf("\nESCL[ŁFI\n");

    //------------ `Ȑ̌_E݁Ec{ݒ --------------------//
	r0[0] = 0.01;   r0[1] = 0.01;       //{_
	wt = 0.004;                         //`UȐԍ(dt=nrkg*0.01)
	wy[0] = wy[1] = 0.5;  wy[2] = 0.5;  //`UȐc{
	rc[0] = -0.99;  rc[1] = r0[1];      //`UȐ_
    wf = 0.005;                         //`g(dz=0.02)
	for(i=0;i<nf;i++)  wa[i] = 0.5;     //`gc{
    rf1[0] = r0[0];    rf1[1] = r0[1];  //`}XPg_
    rf2[0] = r0[0];    rf2[1] = r0[1]-0.9;  //`}XQg_

	yy2[0] = yy0[0];
	yy2[1] = vv0[0];
	yy2[2] = yy0[1];
	yy2[3] = vv0[1];
    t = 0;
	m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = yy2[2];
	yseries[2][m] = Yf*sin(omf*t);
}
/************ dialogue() end ***********************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("2DOFU@m:΂˃}X g:O j: ύX, f:g`");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//-------- ̉ ------//
	for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
		yy1[1] = yy2[1];
	    yy1[2] = yy2[2];
	    yy1[3] = yy2[3];
	    rkg1( t, dt, yy1, yy2, 4);
	    t = t + dt;
	}

	//---U}`Fr0[]_CwycCn}X̐Cyy2[0]U-------------------//
	yfig[0] = yy2[0];  yfig[1] = yy2[2];
	drawfigure2(r0, wy[0], 2, yfig );                          //}X̐U
	//-----------------O͂ŕ\ ----------------------------------------//
	arrowl = 0.3*sin(omf*t)*wy[0];   alpha = PAI/2; arrowd = 0.04*wy[0];
	if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	arrowl = fabs(arrowl);  
    arrow0[0] = r0[0] + (xedge - r0[0])/3;       //̐[}X̏㉺0.2̈ʒu
	arrow0[1] = r0[1] + yy2[0]*wy[0] - arrowd;
	usrDrawArrow2d( arrow0, arrowl, alpha, blue ); 

	//---Ȑ`Fr0[]_CwtԎCwy[]cCn{ȐCm̓_CUa[i][k]
    drawcharacter(-0.95, 0.90, H18,"red    :vibration of mass1 y1(t)");
    drawcharacter(-0.95, 0.85, H18,"green :vibration of mass2 y2(t)");
    drawcharacter(-0.95, 0.80, H18,"blue  :external force F(t)");
    drawcharacter(-0.95, 0.75, H18,"1grid=(1s, 0.2m) or (1s, 0.4N)");
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = yy2[2];
	yseries[2][m] = Yf*sin(omf*t);
	usrDrawAxis2d( rc, 0.0 );
	r1[0] = r0[0] - 30*wt/(nrkg*dt);   r1[1] = r0[1];
    usrGrating( r1, 0.0, 30, wt/(nrkg*dt), 0.2*wy[0] );
	drawcurven( rc, wt, wy, 3, m, yseries, MMAX );               //UȐ

	//---------- g`Frf1,2[]_Cwfg݁Cwac{ --------------//
	if(KEY=='f' || KEY=='y' || KEY=='Y' || KEY=='x' || KEY=='X')
	{
        drawcharacter(0.02, 0.90, H18,"frequency characteristics |Y1| and |Y2|");
        drawcharacter(0.02, 0.85, H18,"zeta2={0, 0.05, 0.1, 0.2, 0.5, 0.707, 1, 2, 5}");
        drawcharacter(0.02, 0.80, H18,"black curve : given zeta2");
        drawcharacter(0.02, 0.75, H18,"blue point : given omf and F");
		//--------- }XP̂ -----------------------//
		drawcurve1(rf1, wf, wa[0], mf, aseriesp1,  black);    //ݒ肵ñ}X1g
		drawcurven(rf1, wf, wa,  nf, mf, aseries1,  MMAX);    //2ς}X1g
		r1[0] = rf1[0] + Amp1[0]/dz*wf;   r1[1] = rf1[1] + wa[0]*Amp1[1];
        usrDrawSolidCircle2d(r1, 0.01, blue);                 //ݒ肵(f,A1)_
		//--------- }XQ̂ -----------------------//
		limit = 0.9;
		drawcurve1limit(rf2, wf, wa[0], mf, aseriesp2, black, limit);    //ݒ肵ñ}X2g
		drawcurvenlimit(rf2, wf, wa, nf, mf, aseries2, MMAX, limit);    //2ς}X2g
		r1[0] = rf2[0] + Amp2[0]/dz*wf;   r1[1] = rf2[1] + wa[0]*Amp2[1];
		if(r1[1]-rf2[1]<limit)  usrDrawSolidCircle2d(r1, 0.01, blue);   //ݒ肵(f,A2)_
	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/


/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	int   i;

	KEY = key;
	if(key=='y' || key=='Y')
	{
		if(key=='y') { for(i=0;i<2;i++)  wy[i] = 0.9*wy[i];
		               for(i=0;i<nf;i++) wa[i] = 0.9*wa[i];  }
		if(key=='Y') { for(i=0;i<2;i++)  wy[i] = wy[i]/0.9;
		               for(i=0;i<nf;i++) wa[i] = wa[i]/0.9;  }
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')
	{
		if(key=='t')	wt = 0.9*wt;
		if(key=='T')	wt = wt/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='x' || key=='X')
	{
		if(key=='x')	wf = 0.9*wf;
		if(key=='X')	wf = wf/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='s')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='m' || key=='g' || key=='j')
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='f')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}



void motion_function(void){ }

/********* drawfigure2() ********************************************************/
//   x_||}X@̍\                                                 //
/********************************************************************************/
void drawfigure2(double r0[], double wy, int n, double a[])
{
	static double  xedge=0.99, dx, r1[2], r2[2];
	static int     i;
	static float   red[]={1.0, 0.0, 0.0, 0.0};

	//-------- Œ_E}XEŒ_Ԃ̌` ---------//
	dx = (xedge - r0[0])/(n+1); 
	r2[0] = r0[0];   r2[1] = r0[1];
	for(i=0;i<n;i++)
	{
		r1[0] = r2[0];        r1[1] = r2[1];
		r2[0] = r1[0] + dx;   r2[1] = wy*a[i]; 
	    usrDrawLine2d( r1, r2, red );
	}
	
    //---------- U[ɌŒ_` -----------------//
	usrDrawSolidCircle2d( r0, 0.01, red );

	//---------- }X̕` ---------------------------//
	r1[0] = r0[0];
	for(i=0;i<n;i++)
	{
		r1[0] = r1[0] + dx;   r1[1] = wy*a[i];
	    usrDrawSolidCircle2d( r1, 0.04, ncolor[i] );
	}
	glFlush();
}
/********** (3) drawfigure2() end ********************************/

/**********		drawcurve1limit() ********************************************/
// drawcurve1limit(r0[], wx, wy, m, a[] color[], ) : 1{̐UȐOt` //
//    莞ԊԊua(t)̋Ȑ`                                         //
//    r0[] : ʏ̐UOt̍[ʒu(_j                             //
//    wf   : X̍                                                   //
//    wa   : Ya[k][]̕`{(2~2j                                //
//    mf   : ()̍ݐ(k=0,1,...,m)̓_`                       //
//    a[i] : iԖڋȐkԖڂ̓_̐U                                      //
/*****************************************************************************/
void drawcurve1limit(double rf[], double wf, double wa, int mf, double a[], float color[], double limit)
{
	int k;
	double r1[2], r2[2];

	glLineWidth(2.0);       	//`悷̑w肷

	//------- Q_ƂlimitȉȂ炻2_𒼐łȂ --------//
	r2[0] = rf[0];  r2[1] = rf[1] + a[0]*wa;
	for(k=1;k<=mf;k++)
	{
		r1[0] = r2[0];         r1[1] = r2[1];
		r2[0] = r1[0] + wf;    r2[1] = rf[1] + a[k]*wa;
		if(r1[1]-rf[1]<limit && r2[1]-rf[1]<limit)	usrDrawLine2d( r1, r2, color );
	}
}
/**************** drawcurve1limit() end ********************************************/

/****(8)*****************************************************************/
// drawcurven(r0[], wx, wy[], n, m, *a, mmax) : n{̐UȐOt` //
//    莞ԊԊun{a(i,t)̋Ȑ`                             //
//    rf[] : ʏ̐UOt̍[ʒu(_j                        //
//    wx   : X̍                                              //
//    wy   : Ya[]̕`{(2~2j                              //
//    n    : `悷Ȑ̐                                           //
//    m    : ()̍ݐ(k=0,1,...,m)̓_`                  //
//    *a=a[i][k] : iԖڋȐkԖڂ̓_̐U                           //
//    color[4]   : `̐F                                             //
/************************************************************************/
void drawcurvenlimit( double rf[], double wx, double wy[], int n, int m, double *a, int mmax, double limit )
{
	int   i;

	//--------- n{̋Ȑ` ---------------------------//
	for(i=0;i<n;i++)
	{
       drawcurve1limit( rf, wx, wy[i], m,  (a+i*mmax), ncolor[i], limit );
	}
}
/********* (8) drawcurvenlimit() end *****************************************/
