
/************************************************************* 2005.8.25 *****/
// phase.c  PRxUn̈ʑʉ
// (1) RU   ddy + 2*ă0*dy + 0^2*y = 0 */
// (2) K^̂n̎RU
// (3) Van der Pol U
//     t:initial time, t+dt:final time,
//     y0[n],y4[n]:initial state, final state, n<10 
/*****************************************************************************/
/*
   FILE *fp;
   char fname[32];
   max=0; data[0]=y0[0];
   if (max < 200) { max++; data[max] = y4[0]; };
   printf("filename=");   scanf("%s",fname);
   fp=fopen(fname,"wt");
      for (j=0;j<max;j++) fprintf(fp,"%f\n",data[j]);
   fclose(fp);
    fp=fopen(fname,"rt");
    while (fscanf(fp,"%f\n",&zz)==1) {
    	printf("%d,%f\n",jj,zz);jj++;
    }
    fclose(fp);
*/
/*
   FILE *fp;
   char fname[32];
*/

   
   
   
#include    <stdio.h>
#include    <conio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          1001
#define   MMAX2         1501
#define   PAI           3.14159265358979e0
#define   PAI2          6.28318530317958e0
static double r0[2];
static double zeta, zeta2, om0;                //,0(ǓEŗLU)
static double eps;                             //(VanderPolEMathieǔW)
static double ym, vm;                          //ǈʒuEZx
static double delta, beta, beta2;              //,(Mathieu̎̌W)
static double Yf, zf;                          //KÓEO͐U
static double A;                               //`U̐U
static double t, dt=0.01;                      //ԂƎԍ
static double yy0, vv0, yy1[2], yy2[2];        //ȔlEXX̕ψʁEx
static double yseries[3][MMAX];                //UψʁExEO͂̎niUȐ`j
static double wt, wy[2];                       //U`̏c{
static int    mt, nt, nf;                      //L̓_̐En񐔁E}X̐
static double pseries[2][MMAX2];               //UψʁEx̎niʑʕ`j
static int    mp;                              //L̓_̐
static double rp[2], wxp, wyp;                 //ʑʌ_ʒuEc{
static double arrowl,arrowd,arrow0[2],alpha;   //}XU}̊O͂ŕ\
unsigned char sgn;                             //V~[VUn̑I
static int    MotionSign;
unsigned char KEY;
void          dialogue();

/************** U ****************************************************/
//       Փ˂ɂԕωrkg()̌ŏ                              //
/******************************************************************************/
double f(int i,double t, double y[])
  {double yy, eps1;
   if(i==0) yy = y[1];
   if(i==1)
     {if(sgn=='1')   yy = -(zeta2*y[1] + y[0]);           //U
      if(sgn=='2') { if(fabs(y[0])<=ym) yy=-zeta2*y[1];   //K^̂錸U
                     if(y[0]<-ym) yy = -(zeta2*y[1] + y[0] + ym);
                     if(y[0]> ym) yy = -(zeta2*y[1] + y[0] - ym); }
      if(sgn=='3') { if(y[0]> 0 ) yy = -(zeta2*y[1] + y[0] + ym);  //\΂ˌn
                     else         yy = -(zeta2*y[1] + y[0] - ym); }
	  if(sgn=='4')   yy =  -(zeta2*y[1] + y[0]);          //ǂ̏ՓːU
	  if(sgn=='b')   yy =  -(zeta2*y[1] + y[0]);          //Ăї̏ՓːU
	  if(sgn=='5')   yy =  -(zeta2*y[1] + y[0]);          //Eǂ̏ՓːU
	  if(sgn=='6')   yy =  -1;                            //d͂ɂ鏰˕Ԃ
	  if(sgn=='7')   yy =  Yf*sin(zf*t) - (zeta2*y[1] + y[0]);
      if(sgn=='8')   yy = eps*(1 - y[0]*y[0])*y[1] - y[0];  //Van der Pol^U
      if(sgn=='9')   yy = -beta2*y[1] - (delta+eps*cos(t))*y[0]; //Mathieu^WU
      if(sgn=='a') { if(t>PAI2)  t = t - PAI2;
	                 if(t<PAI)   eps1 = eps;    else   eps1 = -eps;
					 yy = -beta2*y[1] - (delta+eps1)*y[0];       //`gWU
                   }
     }
   return yy;
  }
/************ f() end *****************************************************/


/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
int main(int argc, char *argv[])
{

	KEY = 'k';
	dialogue();
	DrawGL(&argc, argv);
}
/************* main() end ***************************************************/

/************* dialogue() ***************************************************/
void dialogue(void)
{
	if(KEY=='k')   goto d0;
	if(KEY=='m')   goto d1;
	if(KEY=='j')   goto d2;

d0:
   printf("\nPRxUn̈ʑʏ̃gWFNg");
   printf("\nǂ̌nIԁH");
   printf("\n1:U@      2:K^̂錸U@@3:Ê΂˂l߂U");
   printf("\n4:ǏՓːU@5:ǏՓːU        6:d͂ɂՓːU");
   printf("\n7:ǂUn̏ՓˋU        8:Van der Pol̎");
   printf("\n9:Mathieu̎     a:`gWU        b:Ăї̎U");
   printf("\nsgn = ");   sgn = getch();   printf("%c",sgn);

d1:
   if(sgn=='1')
     {printf("\n1:K`UiKj ddy/dtt + 2dy/dt + y = 0");
      printf("\n  L[́@=  ");   scanf("%lf",&zeta);
      printf("0=1, =%6.3f",zeta);   zeta2=2*zeta;
     }
   if(sgn=='2')
     {printf("\n2:}ym̃K^̂niKjddy/dtt + 2dy/dt + (y-ym) = 0  (abs(y)>ym)");
      printf("\n @@      @@@@@@  @@ ddy/dtt = 0                      (abs(y)<ym)");
      printf("\n  L[́@( K^ym)   ym=");
	  scanf("%lf %lf",&zeta,&ym);     zeta2 = 2*zeta;
     }
   if(sgn=='3')
     {printf("\n3:E΂˂l߂niKjddy/dtt + 2dy/dt + (y+ym) = 0  (y>0)");
      printf("\n @@@@@@@@@@         ddy/dtt + 2dy/dt + (y-ym) = 0  (y<0)");
      printf("\n  L[́@( Ýym)   ym=");
	  scanf("%lf %lf",&zeta,&ym);   zeta2 = 2*zeta;
     }
   if(sgn=='b')
     {printf("\nb:Ăї̎^iKjddy/dtt + 2dy/dt + y = 0  (y>0)");
      printf("\n @@@@@@@@@@       dy/dt = -dy/dt + vm       (y=-ym)");
      printf("\n  L[́@( We  ǍWlym RCɂZx vm)");
	  printf("\n   e ym vm=");
	  scanf("%lf %lf %lf %lf",&zeta,&eps,&ym,&vm);   zeta2 = 2*zeta;   ym = -ym;
     }
   if(sgn=='4')
     {printf("\n4:ɕǂ΂˃}XniKjddy/dtt + 2dy/dt + y = 0  (y>-ym)");
      printf("\n @@@@@@@@@@             dy/dt = -*dy/dt           (y=-ym)");
      printf("\n  L[́@( We  ǂ̍Wlym)  e ym=");
	  scanf("%lf %lf %lf",&zeta,&eps,&ym);   zeta2 = 2*zeta;   ym = -ym;
     }
   if(sgn=='5')
     {printf("\n5:ǂ΂˃}XniKjddy/dtt + 2dy/dt + y = 0  (abs(y)<ym)");
      printf("\n @@@@@@@@@@             dy/dt = -*dy/dt           (abs(y)=ym)");
      printf("\n  L[́@( We  ǂ̈ʒuym>0)    e ym=");
	  scanf("%lf %lf %lf",&zeta,&eps,&ym);   zeta2 = 2*zeta;
     }
   if(sgn=='6')
     {printf("\n6:d͏̏ʔUiKjddy/dtt - 1 = 0      (y>0)");
      printf("\n                     @         dy/dt = -*dy/dt    (y=0)");
      printf("\n  L[́@( We)   e="); 
	  scanf("%lf %lf",&zeta,&eps);   zeta2 = 2*zeta;
	  ym = 0;
     }
   if(sgn=='7')
     {printf("\n7:ǂ΂˃}Xn̋UiKj");
      printf("\n  ddy/dtt + 2dy/dt + y = Yf*sin(zz*t)  (y>-ym)");
      printf("\n  dy/dt = -*dy/dt                      (y=-ym)");
      printf("\n  L[́@( We  ǂ̍Wʒuym)  e ym=");
	  scanf("%lf %lf %lf",&zeta,&eps,&ym);   zeta2 = 2*zeta;   ym = -ym;
	  printf("\n  L[  (UUYf Uzf)  Yf zf=");
	  scanf("%lf %lf",&Yf,&zf);
     }
   if(sgn=='8')
     {printf("\n8:Van der Pol̎iKj");
      printf("\n  ddy/dtt - *(1-y^2)*dy/dt + y = 0");
      printf("\n  L[́@= ");  scanf("%lf",&eps);
     }
   if(sgn=='9')
     {printf("\n9:WU^UPFMathieu̎iKj");
      printf("\n  ddy/dtt + 2*dy/dt+(+*cos(t))*y = 0");
	  printf("\n  ȖݐiÜ萫jɂĂ̓tH_ 15mathieu Q");
      printf("\n  L[́@  = ");
	  scanf("%lf %lf %lf",&beta,&delta,&eps);  beta2 = 2*beta;
     }
   if(sgn=='a')
     {printf("\na:WU^UQF`gUiKj");
      printf("\n  ddy/dtt + 2*dy/dt+(})*y = 0");
	  printf("\n  ȖݐiÜ萫jɂĂ̓tH_ 15mathieu Q");
      printf("\n  L[́@  = ");
	  scanf("%lf %lf %lf",&beta,&delta,&eps);  beta2 = 2*beta;
     }

d2:
   yy0=0;  vv0=2;
   if(sgn=='4' || sgn=='5' || sgn=='7')  printf("\nψʂ͕ǂ̓");
   printf("\nL[́@(y dy/dt)=   ");   scanf("%lf %lf",&yy0,&vv0);
   printf("\n (y,dy/dt)= (%6.3f, %6.3f)  ",yy0,vv0);
   //----- `ÛƂ͎RU̎\ -----------------//
   if(sgn=='1' && zeta<1)
   {
      A=(yy0*zeta + vv0)/sqrt(1 - zeta*zeta);
      A=sqrt(yy0*yy0+A*A);                  //y(t)=A*cos(0*t-)*exp(-ă0*t)
	  printf("\ny(t)=A*cos(0*t-)*exp(-ă0*t) : A=%7.4f",A);
   }

   //------------ L[ɂύX -------------------//
	printf("\n\n's'L[ŁFU`p                    'y','Y'L[ŁFckg");
	printf("\n'k'L[ŁFUn̑I                    't','T'L[ŁFԎkg");
	printf("\n'm'L[ŁFUp[^ύX");
	printf("\n'j'L[ŁFύX");
	printf("\nESCL[ŁFI\n");

	yy2[0] = yy0;
	yy2[1] = vv0;

	yseries[0][0] = yy2[0];
	yseries[1][0] = yy2[1];
	pseries[0][0] = yy2[0];
	pseries[1][0] = yy2[1];

	//--------- `̌_E{ݒ ------------------------//
	mt = mp = 0;
	r0[0] = 0.01;  r0[1] = 0;
	wt = 0.005;
	wy[0] = 0.5;    wy[1] = 0.5;
	if(sgn=='3')  { wy[0] = 0.2;   wy[1] = 0.2; }
	if(sgn=='8')  { wy[0] = 0.2;   wy[1] = 0.2;  wt = 0.005; }

}
/*************** dialogue() end *************************************************/

/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
   if(sgn=='1')
	glutCreateWindow("1:RU @k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='2')
	glutCreateWindow("2:K^̂錸RU@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='3')
	glutCreateWindow("3:\΂˂̌RU@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='4')
	glutCreateWindow("4:ǏՓˎRU    @@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='5')
	glutCreateWindow("5:ǏՓːURU@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='6')
	glutCreateWindow("6:d͂ɂ鏰ՓːU@@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='7')
	glutCreateWindow("7:ǂUn̏ՓˋU@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='8')
	glutCreateWindow("8:Van der Pol̎@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='9')
	glutCreateWindow("Mathieu̎@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='a')
	glutCreateWindow("a:`gWU@@k:n@m:΂˃}XCj: ύX s:p");
   if(sgn=='b')
	glutCreateWindow("b:Ăї̎U@@k:n@m:΂˃}XCj: ύX s:p");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int    i;
	static double rc[2], r1[2], r2[2], p1[2], p2[2];

	//-------------- ǁEƂ̏Փ˂ɂԕω ---------------------------------------//
	//    ǂɂ߂荞񂾉ɂȂψʁǈʒuCx[W*xƂ            //
	//-----------------------------------------------------------------------------------//
	for(i=0;i<5;i++) 
	{
		if(sgn=='4') { if(yy2[0]<-ym)  { yy2[0] = -ym; mt--; break; }
		               if(yy2[0]==-ym && yy2[1]<0) {yy2[1] = eps*fabs(yy2[1]); mt--; break; }
					 }
		if(sgn=='5') { if(yy2[0]<-ym)  { yy2[0] = -ym; mt--; break; }
		               if(yy2[0]==-ym && yy2[1]<0) {yy2[1] = eps*fabs(yy2[1]); mt--; break; }
					   if(yy2[0]> ym)  { yy2[0] =  ym; mt--; break; }
		               if(yy2[0]==ym && yy2[1]>0) {yy2[1] =-eps*fabs(yy2[1]); mt--; break; }
	                 }
		if(sgn=='6')   if(yy2[0]< 0 )  { yy2[0] = 0;   mt--; break; }
		               if(yy2[0]==0 && yy2[1]<0) { yy2[1] = eps*fabs(yy2[1]); mt--; break; }
		if(sgn=='7') { if(yy2[0]<-ym)  { yy2[0] = -ym; mt--; break; }
		               if(yy2[0]==-ym && yy2[1]<0) { yy2[1] = eps*fabs(yy2[1]); mt--; break; }
					 }
		if(sgn=='b') { if(yy2[0]<-ym)  { yy2[0] = -ym; mt--; break; }
		               if(yy2[0]==-ym && yy2[1]<0) {yy2[1] = eps*fabs(yy2[1])+vm; mt--; break; }
					 }
		yy1[0] = yy2[0];
		yy1[1] = yy2[1];
        rkg( t, dt, yy1, yy2, 2);
		t = t + dt;
	}

	usrSetting();


	drawcharacter( 0.05, 0.9,  H18, "phase plane (y, dy/dt)");

	//---Fr0[]_CwycCnf}X̐Cyy2[0]U-------------------//
	nf = 1;
	rc[0] = r0[0] - 0.99;  rc[1] = 0;
/*
	//-------(2)̃P[X  K^͈͕̔` --------------------//
	//-------(5)̃P[X@ǈʒu` --------------------//
	if(sgn=='2' || sgn=='5')
	{   r1[0] = r0[0]-0.99; r1[1] = r0[1] + wy[0]*ym - 0.004;
        usrDrawSolidRectangle2d(r1, 1.0, 0.008, 0, blue);
	    r1[0] = r0[0]-0.99; r1[1] = r0[1] - wy[0]*ym - 0.004;
        usrDrawSolidRectangle2d(r1, 1.0, 0.008, 0, blue);
	}
	//-------(4),(6),(7)̃P[X@ǈʒu` --------------//
	if(sgn=='4' || sgn=='6' || sgn=='7' || sgn=='b')
	{   r1[0] = r0[0]-0.99; r1[1] = r0[1] - wy[0]*ym - 0.004;
        usrDrawSolidRectangle2d(r1, 1.0, 0.008, 0, blue);
	}
*/
	drawfigure(rc, wy[0], nf, &yy2[0] );                          //}X̐U}
	//-------(7)̃P[X@O͂ŕ\ -----------------------------//
	if(sgn=='7')
	{
		arrowl = 0.3*sin(zf*t)*wy[0];   alpha = PAI/2; arrowd = 0.05*wy[0];
	    if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	    arrowl = fabs(arrowl);
        arrow0[0] = rc[0] + 0.5*(xedge - rc[0]);       //̐[}X̏㉺0.2̈ʒu
	    arrow0[1] = rc[1] + yy2[0]*wy[0] - arrowd;
	    usrDrawArrow2d( arrow0, arrowl, alpha, blue ); 
	}
	//---- @end -----------------------------------------------------//

	//---ȐFr0[]_CwtԎCwy[]cCn{ȐCm̓_CUa[i][k]
	drawcharacter(-0.95, 0.9,  H18, "red  : displacement y(t)");
	drawcharacter(-0.95, 0.85, H18, "green: velosity y(t)/dt");
	drawcharacter(-0.95, 0.8,  H18, "blue : external force F(t)");
	drawcharacter(-0.95, 0.75, H18, "1 grid=(1s, 0.5(m,m/s,N)");
	nt = 2;
	mt++;  if( mt > 1.0/wt ) mt = 0;
	yseries[0][mt] = yy2[0];
	yseries[1][mt] = yy2[1];
	if(sgn=='7') { yseries[2][mt] = Yf*sin(zf*t);  nt = 3;  wy[2] = wy[1]; }
	if(sgn=='9') { yseries[2][mt] = cos(t);        nt = 3;  wy[2] = wy[1]; }
	if(sgn=='a') { if(t>PAI2)  t = t - PAI2;
	               if(t<PAI)   yseries[2][mt] = 1;   else yseries[2][mt] = -1;
				   nt = 3;  wy[2] = wy[1]; }

	rc[0] = -0.99;  rc[1] = 0;
	usrDrawAxis2d( rc, 0.0 );
    usrGrating( rc, 0.0, (int)(0.05/wt), 20*wt, 0.5*wy[1] );

	//-------(2)̃P[X  K^͈͕̔` --------------------//
	//-------(5)̃P[X@ǈʒu` --------------------//
	if(sgn=='2' || sgn=='5')
	{   r1[0] = rc[0]; r1[1] = rc[1] + wy[0]*ym - 0.004;
        usrDrawSolidRectangle2d(r1, 1.0, 0.008, 0.0, blue);
	    r1[0] = rc[0]; r1[1] = rc[1] - wy[0]*ym - 0.004;
        usrDrawSolidRectangle2d(r1, 1.0, 0.008, 0.0, blue);
	}
	//-------(4),(6),(7)̃P[X@ǈʒu` --------------//
	if(sgn=='4' || sgn=='6' || sgn=='7' || sgn=='b')
	{   r1[0] = rc[0]; r1[1] = rc[1] - wy[0]*ym - 0.004;
        usrDrawSolidRectangle2d(r1, 1.05, 0.008, 0.0, blue);
	}
	//----------- UȐ` ---------------------//
	drawcurven( rc, wt, wy, nt, mt, yseries, MMAX );
	//------- Ȑ end ---------------------------------------------------//

	//-------ʑʁFrp[]_C(wxp, wyp)c{Cmp_Cpseries[2][](X,Y)_CMMAX2z
    rp[0] = 0.5;  rp[1] = 0;
	wxp = wyp = 0.25;
	if(sgn=='8') wxp = wyp = 0.1;

	//-------- 0 - mp܂ł̕ψʑx_쐬 ------//
	mp++;
    if(mp>MMAX2) mp = 0;
	pseries[0][mp] = yy2[0];
	pseries[1][mp] = yy2[1];


	//---- n_ƏI_ە\ -----------//
	p1[0] = rp[0] + wy[0]*pseries[0][0];
	p1[1] = rp[1] + wy[1]*pseries[1][0];
	usrDrawSolidCircle2d(p1, 0.01, black);
	p2[0] = rp[0] + wy[0]*pseries[0][mp];
	p2[1] = rp[1] + wy[1]*pseries[1][mp];
	usrDrawSolidCircle2d(p2, 0.01, black);

	//---- ʑʂ̍WƋȐ` -----------------------//
	//-------(2)̃P[X  K^͈͕̔` --------------------//
	//-------(5)̃P[X@ǈʒu` --------------------//
	usrDrawAxis2d( rp, 0.0 );
	if(sgn=='2' || sgn=='5')
	{   r1[1] = -2; r1[0] = rp[0] + wy[0]*ym - 0.003;
        usrDrawSolidRectangle2d(r1, 0.008, 4.0, 0, blue);
	    r1[1] = -2; r1[0] = rp[0] - wy[0]*ym - 0.003;
        usrDrawSolidRectangle2d(r1, 0.008, 4.0, 0, blue);
	}
	//-------(4),(6),(7)̃P[X@ǈʒu` --------------//
	if(sgn=='4' || sgn=='6' || sgn=='7' || sgn=='b')
	{   r1[1] = -2; r1[0] = rp[0] - wy[0]*ym - 0.003;
        usrDrawSolidRectangle2d(r1, 0.008, 4.0, 0, blue);
	}
	//------- gWFNg` ----------------------//
//	drawcurve0(rp, wxp, wyp, mp, pseries, MMAX2 );
	drawcurve0(rp, wy[0], wy[1], mp, pseries, MMAX2 );
	//------- ʑʕ` end -------------------------------------------//

	usrFlushAndSwap();
}
/************* usrdisplay() end *********************************************/


/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	KEY = key;

	if(key=='s')
	{
//		t = t + dt;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='k' || key=='m' || key=='j')
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='y' || key=='Y')
	{
		if(key=='y') { wy[0] = 0.9*wy[0];  wy[1] = 0.9*wy[1]; }
		if(key=='Y') { wy[0] = wy[0]/0.9;  wy[1] = wy[1]/0.9; }
		MotionSign = 0; 		usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')
	{
		if(key=='t')  wt = 0.9*wt;
		if(key=='T')  wt = wt/0.9;
		MotionSign = 0; 		usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);
	else     usrdisplay();

end:;


}



void motion_function(void){ }


