/************************************************************* 2006.1.5 ******/
//  forcedvib12.c : PRxŨV~[V                       //
//                  x[XUChU                                   //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          501
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

static double mass, lamda, Kspring;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double a, t, dt=0.01;
static double om, OM, zeta;          //ŗLU(rad/s)CŗLUC
static double Yf, omf, z, zz;     //x[XUU(m)CU(rad/s)
static double dz = 0.02;
static int    mf = 250,  nf = 9;     //g݁CĐ
static double Amps, Ampd, fai;       //Ý(m)CU(m)Cʑx(rad)
static double yy0, vv0, yy1[2], yy2[2], yseries[2][MMAX];
static double aseries[10][MMAX], phseries[10][MMAX]; //g̐UEʑ
static double aseriesp[MMAX], phseriesp[MMAX];       //ݒĂ̎g̐UEʑ
static double Amp[2], Phi[2];        //(f,A),(f,)
static double r0[2], rc[2], rf[2], r1[2];
static double wt, wy[2];             //ψʁExȐ̏c{
static double wf, wa[10], wph[10];   //nf{̎gȐ̏c{
static double arrow0[2], arrowl, alpha, arrowd;
static double transx, transy, rot;
static int    m, n;
static int    nrkg=4;                //nrkg*dtɃf[^擾
static int    MotionSign;
static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};
unsigned char KEY;
void   rkg();
void drawfigure2();
void dialogue();
//double xedge=0.99;

/************** ̉ *********************************************/
double f(int i, double t, double y[])
{
	static double yd, yv, yy;

	if(i==0) yy = y[1];
    if(i==1) { yd = y[0] - Yf*sin(omf*t); yv = y[1] - Yf*omf*cos(omf*t);
	           yy = - (lamda*yv + Kspring*yd )/mass; }
	return yy;
}
/************* f() end *******************************************************/

/************* ǧvZ **********************************************/
//     wf݂ŁC0-m܂ł̐UɂĐUyy[]Eʑfi[]vZ               //
//     z=f/0fŐKĂ                                        //
//     ʑ180=1Ƃ                                                   //
/*****************************************************************************/
void freqcharct(double dz, int m, double zeta, double Yf, double yy[], double fi[])
{
	static double z, zz;
	static int    i;

	for(i=0;i<=m;i++)
	{
		z = i*dz;
		zz = z*z;
		yy[i] = Yf*sqrt( (1 + 4*zeta*zeta*zz)/( (1 - zz)*(1 - zz) + 4*zeta*zeta*zz) );
		fi[i] = ( atan2(2*zeta*z*zz, 1 - (1-4*zeta*zeta)*zz) )/PAI;       //180=1Ƃ
	}
}
/********* freqcharct() end ***************************************************/


/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
int main(int argc, char *argv[])
{
	KEY = 'm';
	dialogue();
	DrawGL(&argc, argv);
}
/*********** main() end *****************************************************/

/*********** dialogue() *****************************************************/
void dialogue(void)
{
	int  i;
	double zeta0[]={0.0, 0.02, 0.05, 0.1, 0.2, 0.7071, 1.0, 2.0, 5.0};

	printf("\n(1) n̒萔ݒ");
	printf("\n(2) O͏ݒ");
	printf("\n(3) ݒ");

	if(KEY=='m')  goto d1;
	if(KEY=='g')  goto d2;
	if(KEY=='j')  goto d3;

d1:
	printf("\nPRxx[XU̕`");
	printf("\nm*ddy/ddy + *(dy/dt-dyf/dt) + K*(y-yf) = 0");
	printf("\nyf=Yf*sin(f*t) ");
	printf("\n\n}Xm[kg]C_p[[N/(m/s)]C΂˒萔K[N/m] L[ m  K=");
	scanf("%lf %lf %lf", &mass, &lamda, &Kspring);
    om = sqrt(Kspring/mass);
	zeta = lamda/(2*sqrt(mass*Kspring));
	if(zeta<=1)  OM = om*sqrt(1 - zeta*zeta); 
	mf = 250;

d2:
	printf("\nŗLU0=%7.4f[rad/s], =%7.4f",om,zeta);
	printf("\nUU|Y(j/0)|/Yf=%7.4f",sqrt(1+4*zeta*zeta)/(2*zeta));
	printf("\n\nx[XUUYf[m]CUf[rad/s]@L[ Yf f=");
	scanf("%lf %lf",&Yf, &omf);
	z = omf/om; 	zz = z*z;
	Amp[0] = Phi[0] = z;
	Amp[1] = Yf*sqrt( (1 + 4*zeta*zeta*zz)/( (1 - zz)*(1 - zz) + 4*zeta*zeta*zz) );
	Phi[1] = ( atan2(2*zeta*z*zz, 1 - (1-4*zeta*zeta)*zz) )/PAI;       //180=1Ƃ
	//---------- gvZ -----------------------------//
    freqcharct(dz, mf, zeta, Yf, aseriesp, phseriesp);
	//---------- ĂςĎgvZ -------------------//
	for(i=0;i<nf;i++)  freqcharct(dz, mf, zeta0[i], Yf, aseries[i], phseries[i]);

d3:
	printf("\nx[XUUYf=%7.4f[m], UUA=%7.4f[m] ʑxꃳ=%6.2f[deg]"
		,Yf,Amp[1],180*Phi[1]);
	printf("\nL[  Î~ԁF'0'  UU '1'  Cӏ '2'");
	i = getch();
	if(i=='0')  yy0 = vv0 = 0;
	if(i=='1') { yy0 = -Amp[1]*sin(Phi[1]*PAI);  vv0 = Amp[1]*omf*cos(Phi[1]*PAI); }
	if(i=='2')	scanf("%lf %lf",&yy0, &vv0);
	if(i!='0' && i!='1' && i!='2')  goto d3;
	printf("\nݒ菉(y0,v0)=(%7.4f[m], %7.4f[m/s])",yy0,vv0);

	//---------- `ʂ傤ł̃L[ ---------------------//
	printf("\n\n's'L[ŁFU`p");
	printf("\n'm'L[ŁF΂˃}XύX");
	printf("\n'g'L[ŁFO͏ύX");
	printf("\n'j'L[ŁFύX");
	printf("\n'f'L[ŁFg`");
	printf("\n'X' or 'x'L[ŁFg̉gk");
	printf("\n'T' or 't'L[ŁFUȐ̎Ԏgk");
	printf("\n'Y' or 'y'L[ŁFUEg̏cgk");
	printf("\nESCL[ŁFI\n");

	//-------- `ʂ̌_E{ ----------------------//
	r0[0] = 0.01;   r0[1] = 0;
	rc[0] = -0.99;  rc[1] = 0;
    rf[0] = r0[0];        rf[1] = 0.0;
	for(i=0;i<nf;i++) { wa[i] = 0.5;    wph[i] = -0.8; }
    wf = 0.005;
	wt = 0.004; wy[0] = 0.5; wy[1] = 0.5;

	yy2[0] = yy0;
	yy2[1] = vv0;
    t = 0;
	m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Yf*sin(omf*t);
}
/************ dialogue() end ***********************************************/

/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("1DOFU@m:΂˃}X g:O j: ύX, f:g`");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//-------- ̉ ------//
	for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
	    yy1[1] = yy2[1];
	    rkg1( t, dt, yy1, yy2, 2);
		t = t + dt;
	}

	//--- }XU}`Fr0[]_CwycCn}X̐Cyy2[0]U -----------//
	r1[0] = r0[0] - 0.025;  r1[1] = r0[1] - 0.05 + wy[1]*Yf*sin(omf*t);
    usrDrawSolidRectangle2d(r1, 0.05, 0.1, 0.0, red);    //x[X̕`
	r1[0] = r0[0];  r1[1] = r0[1] + wy[1]*Yf*sin(omf*t);
	drawfigure2(r1, wy[0], 1, &yy2[0] );                 //}X̐U

	//---Ȑ`Fr0[]_CwtԎCwy[]cCn{ȐCm̓_CUa[i][k]
    drawcharacter(-0.90, 0.90, H18, "red    : mass vibration y(t)");
    drawcharacter(-0.90, 0.85, H18, "green : base vibration yf(t)");
    drawcharacter(-0.90, 0.80, H18, "1grid=(1s, 0.2m)");
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Yf*sin(omf*t);
	r1[0] = r0[0] - 30*wt/(nrkg*dt); r1[1] = r0[1];
	usrDrawAxis2d( rc, 0.0 );
    usrGrating( r1, 0.0, 30, wt/(nrkg*dt), 0.2*wy[0] );
	drawcurven( rc, wt, wy, 2, m, yseries, MMAX );               //UȐ

	//---g`Frf[]_Cwfg݁Cwac{--------//
	if(KEY=='f' || KEY=='x' || KEY=='X' || KEY=='y' || KEY=='Y')
	{
        drawcharacter(0.01, 0.90, H18, "frequency characteristics parameter:zeta");
        drawcharacter(0.01, 0.85, H18, "upperside:Amplitude,  downside:Phase shift");
        drawcharacter(0.01, 0.80, H18, "zeta={0, 0.02, 0.05, 0.1, 0.2, 0.707, 1, 2, 5}");
        drawcharacter(0.01, 0.75, H18, "black curve:given zeta, blue point:given omf");

//printf("\naseries[1][40]=%7.4f ph[1][40]=%6.2f",aseries[1][40],180*phseries[1][40]);
		drawcurven(rf, wf, wa,  nf, mf, aseries,  MMAX);
		drawcurven(rf, wf, wph, nf, mf, phseries, MMAX);
		drawcurve1(rf, wf, wa[0],  mf, aseriesp,  black);
		drawcurve1(rf, wf, wph[0], mf, phseriesp, black);
		r1[0] = rf[0] + Amp[0]/dz*wf;   r1[1] = rf[1] + wa[0]*Amp[1];
        usrDrawSolidCircle2d(r1, 0.01, blue);
		r1[0] = rf[0] + Phi[0]/dz*wf;   r1[1] = rf[1] + wph[0]*Phi[1];
        usrDrawSolidCircle2d(r1, 0.01, blue);

	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/

/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	int  i;

	KEY = key;
	if(key=='y' || key=='Y')
	{
		if(key=='y')  {	wy[0] = 0.9*wy[0]; wy[1] = 0.9*wy[1];
 		                for(i=0;i<nf;i++) wa[i] = 0.9*wa[i]; }
		if(key=='Y')  {	wy[0] = wy[0]/0.9; wy[1] = wy[1]/0.9;
 		                for(i=0;i<nf;i++) wa[i] = wa[i]/0.9; };
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')
	{
		if(key=='t')	wt = 0.9*wt;
		if(key=='T')	wt = wt/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='x' || key=='X')
	{
		if(key=='x')	wf = 0.9*wf;
		if(key=='X')	wf = wf/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='s')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='m' || key=='g' || key=='j')
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='f')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}
/************ keyboard() end ************************************************/


void motion_function(void){ }

/********* drawfigure2() ********************************************************/
//   x_||}X@̍\                                                 //
/********************************************************************************/
void drawfigure2(double r0[], double wy, int n, double a[])
{
	static double  xedge=0.99, dx, r1[2], r2[2];
	static int     i;
	static float   red[]={1.0, 0.0, 0.0, 0.0};

	//-------- Œ_E}XEŒ_Ԃ̌` ---------//
	dx = (xedge - r0[0])/(n+1); 
	r2[0] = r0[0];   r2[1] = r0[1];
	for(i=0;i<n;i++)
	{
		r1[0] = r2[0];        r1[1] = r2[1];
		r2[0] = r1[0] + dx;   r2[1] = wy*a[i]; 
	    usrDrawLine2d( r1, r2, red );
	}
	
    //---------- U[ɌŒ_` -----------------//
	usrDrawSolidCircle2d( r0, 0.01, red );

	//---------- }X̕` ---------------------------//
	r1[0] = r0[0];
	for(i=0;i<n;i++)
	{
		r1[0] = r1[0] + dx;   r1[1] = wy*a[i];
	    usrDrawSolidCircle2d( r1, 0.04, ncolor[i] );
	}
	glFlush();
}
/********** (3) drawfigure2() end ********************************/

