/************************************************************* 2006.1.6 ******/
//  forcedvib11.c : PRxŨV~[V                       //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          501
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

static double mass, lamda, Kspring;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double a, t, dt=0.01;
static double om0, OM, zeta;          //ŗLU(rad/s)CŗLUC
static double Force, omf;             //O͐U(N)CO͐U(rad/s)
static double Amps, Amp[2], Phi[2];   //Ý(m)CU(m)Cʑx(rad)
static double yy0, vv0, yy1[2], yy2[2], yseries[2][MMAX];
static double aseries[10][MMAX], phseries[10][MMAX]; //ĕςg̐UEʑ
static double aseriesp[MMAX], phseriesp[MMAX]; //ݒĂ̎g̐UEʑ
static int    mf, nf;                 //g`̉ݐCȐ
static double wt, wy[2];              //ψʁExȐ̎ԍ݁Ec{
static double wf, wa[10], wph[10];    //nf{̎gȐ`̉݁Ec{
static double r0[2], rc[2], rf[2], r1[2];
static double arrow0[2], arrowl, alpha, arrowd;
static double z, zz, dz;              //UCvZ̐U
static double nrkg=4;                 //nrkg*dtɃf[^擾
static int    m, n;
static int    MotionSign;
unsigned char KEY;
void   rkg();
void dialogue();
//double xedge=0.99;

/************** ̉ *********************************************/
double f(int i, double t, double y[])
{
	static double yy;

	if(i==0) yy = y[1];
    if(i==1) yy = ( Force*sin(omf*t) - (lamda*y[1] + Kspring*y[0]) )/mass;
	return yy;
}
/************* f() end *******************************************************/

/************* ǧvZ **********************************************/
//     wf݂ŁC0-m܂ł̐UɂĐUyy[]Eʑfi[]vZ               //
//     (f,y)ƂKĂ                                               //
/*****************************************************************************/
void freqcharct(double dz, int m, double zeta, double Yf, double yy[], double fi[])
{
	static double z, zz;
	static int    i;

	for(i=0;i<=m;i++)
	{
		z = i*dz;
		zz = z*z;
		if(fabs(z-1)<1.0e-6) { if(zeta==0) yy[i] = 1.0e5;  else yy[i] = Yf/(2*zeta); fi[i] = 0.5; }
		else {
		yy[i] = Yf/sqrt( (1 - zz)*(1 - zz) + 4*zeta*zeta*zz );
		fi[i] = atan2( 2*zeta*z, (1 - zz) )/PAI;       //180=1Ƃ
		}
	}
}
/********* freqcharct() end ***************************************************/


/************************************************************************************/
int main(int argc, char *argv[])
{
	KEY = 'm';
	dialogue();
	DrawGL(&argc, argv);
}
/*********** main() end *****************************************************/

/*********** dialogue() *****************************************************/
void dialogue(void)
{
	static int    i;
	static double zeta0[]={0.0, 0.02, 0.05, 0.1, 0.2, 0.7071, 1.0, 2.0, 5.0};

	printf("\nPRxU̕`");
	printf("\nm*ddy/ddt + *dy/dt + K = F*sin(f*t)");
	if(KEY=='m')  goto d1;
	if(KEY=='g')  goto d2;
	if(KEY=='j')  goto d3;

d1:
	//------------- n̒萔 ----------------------------------//
	printf("\n\n}Xm[kg]C_p[[N/(m/s)]C΂˒萔K[N/m] L[ m  K=");
	scanf("%lf %lf %lf", &mass, &lamda, &Kspring);
    om0 = sqrt(Kspring/mass);
	zeta = lamda/(2*sqrt(mass*Kspring));
	if(zeta<=1)  OM = om0*sqrt(1 - zeta*zeta); 

d2:
	printf("\nŗLU 0=%7.4f[rad/s], =%7.4f",om0,zeta);
	printf("\nUU|Y(j/0)|/Yf=%7.4f",1/(2*zeta));
	//-------------- O͏ ---------------------------------//
	printf("\n\nUUF[N]CUf[rad/s]@L[ F f=");
	scanf("%lf %lf",&Force, &omf);
	Amps = Force/Kspring;
    Amp[0] = Phi[0] = z = omf/om0;  zz = z*z;
	Amp[1] = Amps/sqrt( (1 - zz)*(1 - zz) + 4*zeta*zeta*zz );
	if(z==1)  Phi[1] = 0.5;
	else      Phi[1] = atan2( 2*zeta*z, (1 - zz) )/PAI;       //180=1Ƃ

	//--------------- gvZ -----------------------//
    dz = 0.02;  mf = 300;  nf = 9;
	freqcharct(dz, mf, zeta, Amps, aseriesp, phseriesp);
	//--------------- ĂςĎgvZ -------------//
	for(i=0;i<nf;i++)
		freqcharct(dz, mf, zeta0[i], Amps, aseries[i], phseries[i]);

d3:
	//---------------  ------------------------//
	printf("\nÝ   As=%7.4f[m]",Amps);
	printf("\nU Ad=%7.4f[m]  UAd/As=%7.4f  ʑxꃳ=%6.2f[deg]"
		,Amp[1],Amp[1]/Amps,180*Phi[1]);
	printf("\nL[́@Î~ԁF'0'  UUF'1'  CӐݒ '2'");
	i = getch();
	if(i=='0') yy0 = vv0 = 0;
	if(i=='1')
	{  yy0 = -Amp[1]*sin(Phi[1]*PAI);   vv0 = Amp[1]*omf*cos(Phi[1]*PAI); }
	if(i=='2')
	{  printf("\ny0[m] v0[m/s] = ");  scanf("%lf %lf",&yy0, &vv0);  }
	if(i!='0' && i!='1' && i!='2')  goto d3;
	printf("\n(y0,v0)=(%7.4f[m], %7.4f[m/s])",yy0,vv0);

	//-------------- `ʂł̃L[ -------------//
	printf("\n\n's'L[ŁFU`p");
	printf("\n'm'L[ŁF΂˃}X萔ύX");
	printf("\n'g'L[ŁFO͕ύX");
	printf("\n'j'L[ŁFύX");
	printf("\n'f'L[ŁFg`");
	printf("\n'x' 'X'L[ŁFggk");
	printf("\n'y' 'Y'L[ŁFgEU}cgk");
	printf("\nESCL[ŁFI\n");

	//-------------- U`̌_E{ ----------------//
	wy[0] = wy[1] = 0.5;          //UȐ`c{ 
	r0[0] = 0.01;  r0[1] = 0;     //`{_
	wt = 0.004;                   //UȐ`掞ԍ(nrkg*dt=0.04s)
	rc[0] = -0.99;  rc[1] = 0;    //UȐ`挴_
    rf[0] = r0[0];  rf[1] = r0[1];//g`挴_
    wf = 0.005;                   //g`扡
	for(i=0;i<nf;i++)             //g`c{
	{ wa[i] = 0.5;    wph[i] = -0.8; }

	yy2[0] = yy0;
	yy2[1] = vv0;
    t = 0;
	m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Amps*sin(omf*t);
}
/************ dialogue() end ***********************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("1DOFU@m:΂˃}X g: j: ύX, f:g`");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//-------- ̉ ------//
    for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
	    yy1[1] = yy2[1];
	    rkg1( t, dt, yy1, yy2, 2);
		t = t + dt;
	}

	//--- }X̐U}`Fr0[]_CwycCn}X̐Cyy2[0]U ---------//
	drawfigure(r0, wy[0], 1, &yy2[0] );                          //}X̐U
	//-----------------O͂ŕ\ ----------------------------------------//
	arrowl = 0.3*sin(omf*t)*wy[0];   alpha = PAI/2; arrowd = 0.04*wy[0];
	if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	arrowl = fabs(arrowl);  
    arrow0[0] = r0[0] + 0.5*(xedge - r0[0]);       //̐[}X̏㉺0.2̈ʒu
	arrow0[1] = r0[1] + yy2[0]*wy[0] - arrowd;
	usrDrawArrow2d( arrow0, arrowl, alpha, green ); 
//	void usrDrawArrow2d( double r0[], double a, double alpha, GLfloat color[] )

	//---Ȑ`Fr0[]_CwtԎCwy[]cCn{ȐCm̓_CUa[i][k]
    drawcharacter(-0.90, 0.90, H18, "red  : mass vibration y(t)");
    drawcharacter(-0.90, 0.85, H18, "green: external force F(t)/K");
    drawcharacter(-0.90, 0.80, H18, "1grid=(1s, 0.2m)");
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Amps*sin(omf*t);
	usrDrawAxis2d( rc, 0.0 );
	r1[0] = r0[0] - 30*wt/(nrkg*dt);   r1[1] = r0[1];
    usrGrating( r1, 0.0, 30, wt/(nrkg*dt), 0.2*wy[0] );
	drawcurven( rc, wt, wy, 2, m, yseries, MMAX );               //UȐ

	//---g`Frf[]_Cwfg݁Cwac{--------//
	if(KEY=='f' || KEY=='y' || KEY=='Y' || KEY=='x' || KEY=='X')
	{
		drawcharacter(0.01, 0.90, H18, "frequency characteristics. zeta parameter");
		drawcharacter(0.01, 0.85, H18, "zeta={0, 0.02, 0.05, 0.1, 0.2, 0.707, 1, 2, 5}");
        drawcharacter(0.01, 0.80, H18, "black curve:given zeta");
        drawcharacter(0.01, 0.75, H18, "blue point:given omf");

//printf("\naseries[1][40]=%7.4f ph[1][40]=%6.2f",aseries[1][40],180*phseries[1][40]);
		drawcurven(rf, wf, wa,  nf, mf, aseries,  MMAX);
		drawcurven(rf, wf, wph, nf, mf, phseries, MMAX);
		drawcurve1(rf, wf, wa[0],   mf, aseriesp, black);
		drawcurve1(rf, wf, wph[0],   mf, phseriesp, black);
		r1[0] = rf[0] + Amp[0]/dz*wf;  r1[1] = rf[1] + wa[0]*Amp[1];
		usrDrawSolidCircle2d(r1, 0.01, blue);
		r1[0] = rf[0] + Phi[0]/dz*wf;  r1[1] = rf[1] + wph[0]*Phi[1];
		usrDrawSolidCircle2d(r1, 0.01, blue);

	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/

/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	static  int  i;

	KEY = key;
	if(key=='y' || key=='Y')
	{
		if(key=='y')	{ wy[0] = wy[1] = 0.9*wy[0]; for(i=0;i<nf;i++) wa[i] = 0.9*wa[i]; }
		if(key=='Y')	{ wy[0] = wy[1] = wy[0]/0.9; for(i=0;i<nf;i++) wa[i] = wa[i]/0.9; }
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')
	{
		if(key=='t')	wt = 0.9*wt;
		if(key=='T')	wt = wt/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='x' || key=='X')
	{
		if(key=='x')	wf = 0.9*wf;
		if(key=='X')	wf = wf/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='s')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='m' || key=='g' || key=='j')
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='f')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}



void motion_function(void){ }
