/************************************************************* 2006.1.01 *****/
//  forcedvib22.c : QRxŨV~[V                       //
//                  x[XɋψʐUizUj                         //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          401
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

static double mass1, lamda1, Kspring1;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double mass2, lamda2, Kspring2;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double a, t, dt=0.01;
static double om1, zeta1;            //ŗLU((K1+K2)/m1(rad/s))C
static double om2, zeta2;            //ŗLU(k2/m2)(rad/s))C
static double om12, zeta12;          //ŗLU(k2/m1(rad/s))C
static double zeta10, zeta20, zeta120, lmd2; //ꎞێ
static double om01, om02;            //ŗLU01,02
static double p2, p12, p2s, p12s;    //U(2/1), (12/1)
static double Yf, omf, z, dz, zz;    //x[XUU(m)CU(rad/s), U(f/1)
static double Ym[2][2];              //Q̋UU
static double Ya[2];                 //UU
static double Amp1[2], Amp2[2];      //O͐UƂ̂Ƃ̒U1,2(m)
static double yy0[2], vv0[2], yy1[4], yy2[4], yseries[3][MMAX];
static double yfig[2];               //}X`悷UU
static double aseries1[10][MMAX], aseries2[10][MMAX]; //ĕςm1,2̎g
static double aseriesp1[MMAX], aseriesp2[MMAX];       //ݒ肵nm1,2̎g
static int    mf, nf;                //g̉ݐCȐ
static double wt, wy[2];             //ψʁExȐ̏c{
static double wf, wa[10], wph[10];   //nf{̎gȐ̏c{
static double r0[2], rc[2], rf[2];   //`{_EUȐEg_
double    r1[2];                     //ƕϐ
int       nrkg=5;                    //nrkg*dtɃTv擾
static double arrow0[2], arrowl, alpha, arrowd;
static int    m, n;
static int    MotionSign;
unsigned char KEY;
void   rkg();
void drawfigure2();
void dialogue();
//double xedge=0.99;

/************** ̉ *********************************************/
double f(int i, double t, double y[])
{
	static double yd, yv, yy;

	if(i==0) yy = y[1];
	if(i==2) yy = y[3];
    if(i==1) { yd = Yf*sin(omf*t);    yv = Yf*omf*cos(omf*t);
	           yy = -( lamda1*(y[1] - yv) + lamda2*(y[1]-y[3])
				   + Kspring1*(y[0] - yd) + Kspring2*(y[0]-y[2]) )/mass1; }
	if(i==3) yy = -(lamda2*(y[3]-y[1]) + Kspring2*(y[2]-y[0]) )/mass2;
	return yy;
}
/************* f() end *******************************************************/

/************** ǧvZ **********************************************/
//     2DOFUfFx[XUɑ΂}XPCQ̉                //
//     z=f/1ɑ΂}XPCQ̐UAmp[0,1]vZ                        //
//     (1-z^2+2j1*z) * A1  + (p12^2+2*12*p12*z)*A2 = Yf                   //
//     (p2^2+2*2*p2*z)*A1 +    (p2^2-z^2+2j2) * A2 = 0                    //
/******************************************************************************/
void f_a_relation22(double z, double Amp[])
{
	static double zz, A1, B1, A2, B2, A12, B12, A21, B21, Af, Bf, delta;
	static double DR1, DI1, DR2, DI2;

	zz  = z*z;
	A1  = 1 - zz;	    B1  = 2*zeta1*z;
	A12 = p12s; 	    B12 = 2*zeta12*p12*z;
	A21 = p2s;  	    B21 = 2*zeta2*p2*z;
	A2  = p2s - zz; 	B2  = 2*zeta2*p2*z;
	Af  = 1 - p12s;     Bf  = B1 - B12;
	DR1  = (A1*A2 - B1*B2) - (A12*A21 - B12*B21);
	DI1  = (A1*B2 + A2*B1) - (A12*B21 + A21*B12);
	delta = DR1*DR1 + DI1*DI1;
	DR2  = Af*A2 - Bf*B2;
	DI2  = Af*B2 + Bf*A2;
	Amp[0] = sqrt( (DR2*DR2 + DI2*DI2)/delta );
	DR2  = A21*Af - B21*Bf;
	DI2  = A21*Bf + B21*Af;
	Amp[1] = sqrt( (DR2*DR2 + DI2*DI2)/delta );
}
/******** f_a_relation22() end **************************************************/



/************************************************************************************/
int main(int argc, char *argv[])
{

	static int i, k, m, n;
	static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};
	static double D, aa[2];

	KEY = 'm';
	dialogue();
	DrawGL(&argc, argv);
}
/******************* main() end *************************************************/

/*********** dialogue() *****************************************************/
void dialogue(void)
{
	static int i, k, m, n;
	static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};
	static double D, aa[2];

	if(KEY=='m')  goto d1;            //n̒萔ύX
	if(KEY=='g')  goto d2;            //O͕ύX
	if(KEY=='j')  goto d3;            //ύX

d1:
	//------------------ 2DOFUn萔L[ -------------------------//
    printf("\nQRxU̕`Fx[XψʋUizUj");
	printf("\nm1*ddy1/ddt + 1*dy1/dt + K1*y1 + 2*(dy1/dt-dy2/dt) + K2*(y1-y2) = yf");
	printf("\nm2*ddy2/ddt + 2*(dy1/dt-dy2/dt) + K2*(y1-y2) = 0");
	printf("\nyf=F*sin(f*t) \n");
	printf("\n(1) n̒萔ݒ");
	printf("\n(2) O͏ݒ");
	printf("\n(3) ݒ\n");

	printf("\n(1-1) }Xm1[kg]C_p[1[N/(m/s)]C΂˒萔K1[N/m]");
	printf("\n@     L[ m1 1 K1=  ");
	scanf("%lf %lf %lf", &mass1, &lamda1, &Kspring1);
	printf("(1-2) }Xm2[kg]C_p[2[N/(m/s)]C΂˒萔K2[N/m]");
	printf("\n@     L[ m2 2 K2=  ");
	scanf("%lf %lf %lf", &mass2, &lamda2, &Kspring2);
	//------------ gvẐ߂̒萔ϊ(1ŐK) ---------------//
    om1   = sqrt( (Kspring1+Kspring2)/mass1);    //1=((K1+K2)/m1)
    om2   = sqrt(Kspring2/mass2);                //2=(K2/m2)
    om12  = sqrt(Kspring2/mass1);                //12=(K2/m1)
	p2    = om2/om1;    p2s  = p2*p2;            //p1=12/1
	p12   = om12/om1;   p12s = p12*p12;          //p12=12/1
	zeta1 = (lamda1+lamda2)/(2*mass1*om1);       //1=(1+2)/(2*m1*1)
	zeta2 = lamda2/(2*mass2*om2);                //2=2/(2*m2*2)
	zeta12= lamda2/(2*mass1*om12);               //12=2/(2*m1*12)
    //----------- ŗLU01,02vZ ------------------------------------//
	D     = sqrt( (1+p2s)*(1+p2s) - 4*p2s*(1-p12s) );
	om01  = 0.5*(1+p2s - D);
	om02  = 0.5*(1+p2s + D);
	om01 = sqrt(om01)*om1;
	om02 = sqrt(om02)*om1;
	//------------ gvZ ----------------------------//
    dz = 0.02;  mf = 300;
	for(k=0;k<=mf;k++)
	{    z = k*dz;
	     f_a_relation22(z, aa);
		 aseriesp1[k] = aa[0];
		 aseriesp2[k] = aa[1];
	}
    //----------- 1,2U_(01,02)̐UvZ -----------------------------//
	z = om01/om1;
	f_a_relation22(z, aa);	Ym[0][0] = aa[0];	Ym[0][1] = aa[1];
	z = om02/om1;
	f_a_relation22(z, aa);	Ym[1][0] = aa[0];	Ym[1][1] = aa[1];
	z = om2/om1;	f_a_relation22(z, aa);	Ya[0] = aa[0];	    Ya[1] = aa[1];

	printf("\n1=(K1+K2)/m1=%7.4f[rad/s],  1=(1+2)/(2*m1*1)=%7.4f",om1,zeta1);
	printf("\n2 =  K2/m2  =%7.4f[rad/s],  2=    2/(2*m2*2)  =%7.4f",om2,zeta2);
	printf("\n12=  K2/m1  =%7.4f[rad/s],  12=   2/(2*m1*12) =%7.4f",om12,zeta12);
	//------------ ̃ĂɂĂ̎gvZ -------------------//
    dz = 0.02;  mf = 300;
	zeta10 = zeta1;	zeta20 = zeta2;	zeta120 = zeta12;  //̒lێ
	nf = 9;
	for(i=0;i<nf;i++)
	{
		zeta2 = zeta0[i];                        //2=2/(2*m2*2)
		lmd2  = zeta2*2*mass2*om2; 
	    zeta1 = (lamda1+lmd2)/(2*mass1*om1);   //1=(1+2)/(2*m1*1)
	    zeta12= lmd2/(2*mass1*om12);           //12=2/(2*m1*12)
		for(k=0;k<=mf;k++)
		{    z = k*dz;
		     f_a_relation22(z, aa);
			 aseries1[i][k] = aa[0];
			 aseries2[i][k] = aa[1];
		}
	}
	zeta1 = zeta10;	zeta2 = zeta20;	zeta12 = zeta120;  //̒lA

d2:
	//----------------- O͏ -----------------------------------------//
	printf("\nŗLU  0[1,2]=(%7.4f  %7.4f)[rad/s]", om01,om02);
	printf("\n1U2UYm1[1,2]=(%7.4f %7.4f)[m](KUj",Ym[0][0],Ym[0][1]);
	printf("\n2U2UYm2[1,2]=(%7.4f %7.4f)[m](KUj",Ym[1][0],Ym[1][1]);
	printf("\nUU 2    = %7.4f[rad/s]",om2);
	printf("\nUU@ Ya[1,2]=(%7.4f %7.4f)[m]",Ya[0],Ya[1]);
	printf("\nQ}Xn 2= %7.4f",zeta2);
	printf("\n\n(2) x[XUUYf=1[m]CUf[rad/s]@L[  f=");
	scanf("%lf",&omf);
	Yf = 1;
	z = omf/om1;
    f_a_relation22(z, aa);
	Amp1[0] = z;  Amp1[1] = aa[0];     //O͐Uf̂Ƃm1̐U
	Amp2[0] = z;  Amp2[1] = aa[1];     //O͐Uf̂Ƃm2̐U

d3:
	//--------------- L[ --------------------------//
	printf("\n   O͐U z=f/1=%7.4f",z);
	printf("\n   x[XUU Yf=%7.4f[m], UU A1=%7.4f[m] A2=%7.4f[m]"
		,Amp1[0],Yf,Amp1[1]*Yf,Amp2[1]*Yf);
	printf("\n(3) L[[m] [m/s]@y01 v01 y02 v02= ");
	scanf("%lf %lf %lf %lf",&yy0[0], &vv0[0],&yy0[1],&vv0[1]);

	printf("\n");
	printf("\n's'L[    FU`p");
	printf("\n'm'L[    F΂˃}X萔ύX");
	printf("\n'g'L[    FO͏ύX");
	printf("\n'j'L[    FύX");
	printf("\n'f'L[    Fg`");
	printf("\n'X' 'x'L[ŁFggk");
	printf("\n'T' 't'L[ŁFUȐԎgk");
	printf("\n'Y' 'y'L[ŁFUEgcgk");
	printf("\nESCL[ŁFI\n");

	wt = 0.004;                     //UȐ`掞ԍ
	wy[0] = 0.5;                    //Uψʕ`c{
	wy[1] = 0.5;                    //Ux`c{
	wy[2] = 0.5;                    //O͕`c{
	wf = 0.01;                      //g`扡
	for(i=0;i<nf;i++)  wa[i] = 0.5; //g`c{
  	rf[0] = r0[0];     rf[1] = 0.0; //g`挴_
	rc[0] = -0.99;     rc[1] = 0;   //UȐ`挴_

	yy2[0] = yy0[0];
	yy2[1] = vv0[0];
	yy2[2] = yy0[1];
	yy2[3] = vv0[1];
    t = 0;
	m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = yy2[2];
	yseries[2][m] = sin(omf*t);
}
/************ dialogue() end ***********************************************/

/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("zU@m:΂˃}X萔 g:O j: ύX, f:g`");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//-------- ̉ ------//
	for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
 	    yy1[1] = yy2[1];
	    yy1[2] = yy2[2];
	    yy1[3] = yy2[3];
	    rkg1( t, dt, yy1, yy2, 4);
        t = t + dt;
	}

	usrDrawAxis2d( r0, 0.0 );

	//--- }XU}`Fr0[]_CwycCn}X̐Cyy2[0]U-------------------//
	r1[0] = 0.01;  r1[1] = wy[0]*sin(omf*t);
	yfig[0] = yy2[0];  yfig[1] = yy2[2];
	drawfigure2(r1, wy[0], 2, yfig );                          //}X̐U
	r1[0] = r1[0] - 0.03;  r1[1] = r1[1] - 0.05;
    usrDrawSolidRectangle2d(r1, 0.06, 0.10, 0.0, blue);         //x[X̐U

	//---Ȑ`Fr0[]_CwtԎCwy[]cC3{ȐCm̓_CUa[i][k]
    drawcharacter(-0.95, 0.90, H18, "red  :1st mass vibration y1(t)");
    drawcharacter(-0.95, 0.85, H18, "green:2nd mass vibration y2(t)");
    drawcharacter(-0.95, 0.80, H18, "blue :base vibration   yf(t)");
    drawcharacter(-0.95, 0.75, H18, "1grid=(1s,0.2m)");
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = yy2[2];
	yseries[2][m] = sin(omf*t);
	r1[0] = r0[0] - 30*wt/(nrkg*dt);  r1[1] = r0[1];
    usrGrating( r1, 0.0, 30, wt/(nrkg*dt), 0.2*wy[0] );
	drawcurven( rc, wt, wy, 3, m, yseries, MMAX );               //UȐ
//  drawcurven( double r0[], double wx, double wy[], int n, int m, double *a, int mmax )

	//---g`Frf[]_Cwfg݁Cwac{--------//
	if(KEY=='f' || KEY=='x' || KEY=='X' || KEY=='y' || KEY=='Y')
	{
        drawcharacter(0.02, 0.90, H18, "frequency characteristics abs[Y1(om)]");
        drawcharacter(0.02, 0.85, H18, "zeta2={0 0.05, 0.1, 0.2, 0.5, 0.707, 1, 2, 5}");
        drawcharacter(0.02, 0.80, H18, "black:given zeta");
        drawcharacter(0.02, 0.75, H18, "blue point:given om and amplitude");
		drawcurven(rf, wf, wa,  nf, mf, aseries1, MMAX);
		drawcurve1(rf, wf, wa[0], mf, aseriesp1, black);
		r1[0] = rf[0] + Amp1[0]/dz*wf;   r1[1] = rf[1] + Amp1[1]*wa[0];
        usrDrawSolidCircle2d(r1, 0.01, blue);
	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/


/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	int  i;

	KEY = key;
	if(key=='y' || key=='Y')
	{
		if(key=='y') {	for(i=0;i<3;i++)  wy[i] = 0.9*wy[i];
		                for(i=0;i<nf;i++) wa[i] = 0.9*wa[i]; }
		if(key=='Y') {	for(i=0;i<3;i++)  wy[i] = wy[i]/0.9;
		                for(i=0;i<nf;i++) wa[i] = wa[i]/0.9; }
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')
	{
		if(key=='t')	wt = 0.9*wt;
		if(key=='T')	wt = wt/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='x' || key=='X')
	{
		if(key=='x')	wf = 0.9*wf;
		if(key=='X')	wf = wf/0.9;
		mf = 1/wf;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='s')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='m' || key=='g' || key=='j')
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='f')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}



void motion_function(void){ }

/********* drawfigure2() ********************************************************/
//   x_||}X@̍\                                                 //
/********************************************************************************/
void drawfigure2(double r0[], double wy, int n, double a[])
{
	static double  xedge=0.99, dx, r1[2], r2[2];
	static int     i;
//	static float   red[]={1.0, 0.0, 0.0, 0.0};

	//-------- Œ_E}XEŒ_Ԃ̌` ---------//
	dx = (xedge - r0[0])/(n+1); 
	r2[0] = r0[0];   r2[1] = r0[1];
	for(i=0;i<n;i++)
	{
		r1[0] = r2[0];        r1[1] = r2[1];
		r2[0] = r1[0] + dx;   r2[1] = wy*a[i]; 
	    usrDrawLine2d( r1, r2, red );
	}
	
    //---------- U[ɌŒ_` -----------------//
	usrDrawSolidCircle2d( r0, 0.01, red );

	//---------- }X̕` ---------------------------//
	r1[0] = r0[0];
	for(i=0;i<n;i++)
	{
		r1[0] = r1[0] + dx;   r1[1] = wy*a[i];
	    usrDrawSolidCircle2d( r1, 0.04, ncolor[i] );
	}
	glFlush();
}
/********** (3) drawfigure() end ********************************/

