/************************************************************* 2005.8.25 *****/
//  forcedvibn.c : nRxUnŨV~[V                   //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          521
#define   PAI           3.14159265358979
#define   NFREE         21
#define   NFREE2        42
static double r0[2], rc[2], rf[2];             //U}EȐEg̊e`挴_
static double mass[NFREE], Kspring[NFREE],lamda[NFREE];     //}X(kg)E΂˒萔(N/m)
static double Force, omf;                      //UU(N)EU(rad/s)
static double FM[NFREE];                       //Up}XQ
static int    kforce;                          //kԖڂ̃}X쓮
static double a, t, dt=0.01, th;
static double om[NFREE];                       //ŗLU(rad/s)
static double yy0[NFREE], vv0[NFREE];          //
static double yy1[NFREE2], yy2[NFREE2];        //RKG()̏lƍŏIl
static double ya[NFREE], yseries[NFREE][MMAX]; //UȐ̓_
double        fseries[MMAX];                   //O͐U_
static double aseries0[NFREE][MMAX];           //n̃}X̎g(Ȃ)
static double aseries1[NFREE][MMAX];           //n̃}X̎g()
static double wt, wy[NFREE], wf, dom, omx, wa[NFREE];
static int    nf, mf, wmf, momf;               //gȐ̖{C_CO͐Uԍ
static double aa[NFREE][NFREE];                //[A]*X=F̍s[A]
static double AR[NFREE][NFREE], BI[NFREE][NFREE]; //[A+jB]*[X+jY]=[F]̍s
static double amode[NFREE][NFREE];             //ŗL[hs
static double arrow0[2], arrowl, arrowd, alpha;       //O͍p_ɖ
static double transx, transy, rot;
static int    nfree;                           //Rx
int           nrkg=4;                          //nrkg*dtɃf[^
static int    mc, nc;                          //UȐ̕`悷{C_
static char   dampsign;                        //_p[́PCȂO
static int    MotionSign;
unsigned char KEY;
void   rkg();
double imatrx();
void   dialogue();


/************* U͂̊{֐Q ****************************************/
//  (1)  compnnt()  : U̎̌Wݒ
//  (2)  compnnti() : Ű̌Wݒ
//  (3)  freq()     : ŗLUvZ
//  (4)  mode()     : ŗLU[hvZ
//  (5)  f()        : U̔
//  (6)  fresponse0() : nDOF̌Ȃn̋Uɑ΂鉞igj
//  (7)  fresponse1() : nDOF̌n̎g
/***************************************************************************/

/****** (1) compnnt() UisǰWƊO̓xNg *************/
//     x=f^2
//     AR[][]Fs
/***************************************************************************/
void compnnt( double x )
  {static int i, j;

   for(i=0;i<nfree;i++) for(j=0;j<nfree;j++) AR[i][j]=0;
   for(i=0;i<nfree-1;i++)  AR[i][i+1] = -Kspring[i+1];
   for(i=1;i<nfree;  i++)  AR[i][i-1] = -Kspring[i];
   for(i=0;i<nfree;  i++)  AR[i][i]   = -mass[i]*x + Kspring[i] + Kspring[i+1];
  }
/****** (2) compnnti() Ws̋ **************************************/
//     [A+jB]*[X+jY]=[F] : ̂ňWs̋[B]ƊO̓xNg[F]
//     x=f
//     BI[][]Fs
//   @FM[]  FO̓xNgiłkforceԖڃ}X1(N)pƂj
/***************************************************************************/
void compnnti( double x )
  {static int i, j;
   
   for(i=0;i<nfree;i++) for(j=0;j<nfree;j++) BI[i][j]=0;
   for(i=0;i<nfree;i++)    BI[i][i]   = (lamda[i] + lamda[i+1])*x;
   for(i=0;i<nfree-1;i++)  BI[i][i+1] = -lamda[i+1]*x;
   for(i=1;i<nfree;i++)    BI[i][i-1] = -lamda[i]*x;
  }

/***** (3) freq() Ȃ̐U(ŗLU)Newton@ɂ ******/
void freq()
  {static double x1,x2,x3,x4,y1,y2,y3,y4,dx,err=1.0e-4;
   static int    i,j,ix;
   x1=0.001;
   dx=0.001;
   compnnt(x1);
//   y1=imatrx(nfree,AR,NFREE);
   y1=determ(nfree,AR,NFREE);
   ix=0;
p1:
   if(x1>0.1) dx=0.01;
   if(x1>1) dx=0.025;
   x2=x1+dx;
   compnnt(x2);
//   y2=imatrx(nfree,AR,NFREE);
   y2=determ(nfree,AR,NFREE);
   if(y1*y2>0)  {x1=x2; y1=y2; goto p1;}
/*
printf("\n**ix=%d,x1,x2  y1,y2=%12.4e,%12.4e, %12.4e,%12.4e",ix,x1,x2,y1,y2);
getch();
*/
   x3=x2; y3=y2;
p2:
   x4=x1-(x2-x1)/(y2-y1)*y1;
   compnnt(x4);
//   y4=imatrx(nfree,AR,NFREE);
   y4=determ(nfree,AR,NFREE);
/*
printf("\n**ix=%d,(x4,y4) y4/y3=(%12.4e,%12.4e), %12.4e",ix,x4,y4,y4/y3);
getch();
*/
   if(fabs(y4/y3)<err)  goto p3;
   if(y1*y4<0) {y2=y4; x2=x4; goto p2;}
   else        {y1=y4; x1=x4; goto p2;}
p3:
   om[ix]=sqrt(x4);
   ix++;
   if(ix<nfree) {x1=x3; y1=y3; goto p1;}

  }
/*********(4) mode() Ȃ̐U[ȟvZ *******************************/
void mode(void)
{
   static int i, j, jj;
   static double x,cc[NFREE];

   for(i=0;i<nfree;i++)
     {x=om[i]*om[i];
      compnnt(x);
      amode[i][nfree-1]=1;
      for(j=0;j<nfree-1;j++) cc[j]=-AR[j][nfree-1];
      imatrx(nfree-1,AR,NFREE);
      for(j=0;j<nfree-1;j++)
        {amode[i][j]=0;
         for(jj=0;jj<nfree-1;jj++)  amode[i][j]=amode[i][j] + AR[j][jj]*cc[jj];
        }
/*
printf("\nbb[][]=(%11.3e, %11.3e, %11.3e)",amode[i][0],amode[i][1],amode[i][2]);getch();
*/
     }
   for(i=0;i<nfree;i++)
     {for(j=1;j<nfree;j++) amode[i][j]=amode[i][j]/amode[i][0];  amode[i][0]=1;}
/*
printf("\nbb[][]=(%11.3e, %11.3e, %11.3e)",amode[i][0],amode[i][1],amode[i][2]);getch();
*/
  }

/******** (5) f()  ***************************************************/
double f(int i, double t, double y[])
{
	static double yy;
	static int    I, J;

	if(nfree==1)
	{ if(i==0) yy = y[1];
	  if(i==1) { yy = (Kspring[0]+Kspring[1])*y[0] + (lamda[0]+lamda[1])*y[1];
	             yy = (Force*sin(omf*t) - yy)/mass[0];  }
	  return yy;
	}
	J = i/2;	I = 2*J;
	if(i==I) { yy = y[i+1];  return yy; }
	if(i==1) { yy = Kspring[0]*y[0] + Kspring[1]*(y[0]-y[2])
		          + lamda[0]*y[1] + lamda[1]*(y[1]-y[3]);
	           if(kforce==0)  yy = yy - Force*sin(omf*t);
               yy = -yy/mass[0];  return yy;  }
	if(i==2*nfree-1)
	         { yy = Kspring[nfree-1]*(y[i-1]-y[i-3]) + Kspring[nfree]*y[i-1]
			      + lamda[nfree-1]*(y[i]-y[i-2]) + lamda[nfree]*y[i];
	           if(kforce==nfree-1)  yy = yy - Force*sin(omf*t);
	           yy = -yy/mass[nfree-1];  return yy;  }
	else     { yy = Kspring[J]*(y[i-1]-y[i-3]) + Kspring[J+1]*(y[i-1]-y[i+1])
		          + lamda[J]*(y[i]-y[i-2]) + lamda[J+1]*(y[i]-y[i+2]);
	           if(kforce==J)  yy = yy - Force*sin(omf*t);
               yy = -yy/mass[J];  return yy;  }
}

/******** (6) fresponse0() O͂ɑ΂鉞igj**********************/
//    SẴ}X̉AMP[]𐳋KĂȂ`ŋ߂
//    kforce : 쓮}X̔ԍ
//    omf    : O͂̐U
//    Amp[]  : PԖڃ}X̒UU
/********************************************************************************/
void fresponse0(double omf, double Amp[])
{
	static double aa[NFREE][NFREE], det;
	static int    i, k;

	compnnt( omf*omf );
	for(i=0;i<nfree;i++)  for(k=0;k<nfree;k++)   aa[i][k] = AR[i][k];

	det = imatrx(nfree, aa, NFREE);

	if(fabs(det)<1.0e-6)  for(i=0;i<nfree;i++) Amp[i] = 1.0e5;
	else   for(i=0;i<nfree;i++)	
	{    Amp[i] = 0; for(k=0;k<nfree;k++) Amp[i] = Amp[i] + aa[i][k]*FM[k];  }
}

/******** (7) fresponse1() n̎g ****************************/
//     F[A+jB]*[X+jY]=[F] ̉ Z=abs(X+jY)
//    CC[][]=[A, -B]  FF[]=[F]    [X]=inv(CC[][])*FF[]  Amp[]=sqrt(X*X+Y*Y)
//           [B,  A]       [0]    [Y]
//    AR[][], BI[][] : Ws̎Ƌ@componnt2()ŗ^ĂƂ
//    F[]            : O̓xNg
//    XR[], YI[], Amp[] : (0 - nfree-1)}X̉(EEΒl)
/*********************************************************************************/
void fresponse1(double omf, double X[], double Y[], double Amp[], double Phi[])
{
	static int  i, k;
	static double det, CC[NFREE2][NFREE2];
	static double a[3], b[3];

	compnnt(omf*omf);
	compnnti(omf);
	for(i=0;i<nfree;i++) for(k=0;k<nfree;k++) CC[i][k] = AR[i][k];
	for(i=0;i<nfree;i++) for(k=0;k<nfree;k++) CC[i][nfree+k] =-BI[i][k];
	for(i=0;i<nfree;i++) for(k=0;k<nfree;k++) CC[nfree+i][k] = BI[i][k];
	for(i=0;i<nfree;i++) for(k=0;k<nfree;k++) CC[nfree+i][nfree+k] = AR[i][k];
/*
printf("\nfresponse1()");
printf("\nAR[][]=(%7.4f %7.4f %7.4f)  F[]=%7.4f",AR[0][0],AR[0][1],AR[0][2],FM[0]);
printf("\n       (%7.4f %7.4f %7.4f)      %7.4f",AR[1][0],AR[1][1],AR[1][2],FM[1]);
printf("\n       (%7.4f %7.4f %7.4f)      %7.4f",AR[2][0],AR[2][1],AR[2][2],FM[2]);
printf("\nBI[][]=(%7.4f %7.4f %7.4f)",BI[0][0],BI[0][1], BI[0][2]);
printf("\n       (%7.4f %7.4f %7.4f)",BI[1][0],BI[1][1], BI[1][2]);
printf("\n       (%7.4f %7.4f %7.4f)",BI[2][0],BI[2][1], BI[2][2]);
*/
	det = imatrx(2*nfree, CC, NFREE2);
	
	for(i=0;i<nfree;i++) { X[i] = 0;
	                       for(k=0;k<nfree;k++) X[i] = X[i] + CC[i][k]*FM[k];
	}
	for(i=0;i<nfree;i++) { Y[i] = 0;
	                       for(k=0;k<nfree;k++) Y[i] = Y[i] + CC[nfree+i][k]*FM[k];
	}
	for(i=0;i<nfree;i++)  Amp[i] = sqrt(X[i]*X[i] + Y[i]*Y[i]);
	for(i=0;i<nfree;i++)  Phi[i] = atan2(Y[i], X[i]);

/*
for(i=0;i<3;i++) {a[i]=0;for(k=0;k<3;k++) a[i]=a[i]+AR[i][k]*X[k]-BI[i][k]*Y[k];}
for(i=0;i<3;i++) {b[i]=0;for(k=0;k<3;k++) b[i]=b[i]+AR[i][k]*Y[k]+BI[i][k]*X[k];}
printf("\n   f = %7.4f  det(CC)= %7.4f",omf,det);
printf("\n    X  =(%7.4f %7.4f %7.4f)",X[0],X[1],X[2]);
printf("\n    Y  =(%7.4f %7.4f %7.4f)",Y[0],Y[1],Y[2]);
getch();
printf("\nA*X-B*Y=(%7.4f %7.4f %7.4f)",a[0],a[1],a[2]);
printf("\n    F  =(%7.4f %7.4f %7.4f)",FM[0],FM[1],FM[2]);
printf("\nA*Y+B*X=(%7.4f %7.4f %7.4f)",b[0],b[1],b[2]);
getch();
*/ 
}

/************* U͂̊{֐Q I ***************************************/




/*********************************************************************************/
/*********************************************************************************/
/*********************************************************************************/
/*********************************************************************************/
/******* main() ******************************************************************/
int main(int argc, char *argv[])
{
//	static int    i, k;
//	static double a, b, c, d, Amp[MMAX];
	KEY = 'n';
	dialogue();

	DrawGL(&argc, argv);
}
/******* main() end *************************************************************/


/******* dialogue() ********************************************************/
void dialogue( void )
{
	static int    i, k;
	static double XR[NFREE], YI[NFREE], Amp[NFREE], PHI[NFREE];

	if(KEY=='n')  goto d1;
	if(KEY=='m')  goto d2;
	if(KEY=='g')  goto d5;
	if(KEY=='j')  goto d6;

//---------- n̎RxnfreeCUȐ`̖{ -----------------//
d1:
	printf("\nnRxU̕` (K:΂ˁ@:}X");
	printf("\nj1[1|j2[2[.....|n|j(n+1)  ̍\\n");
	printf("\nkԖڃ}X쓮 F*sin(f*t), k=1,...,nfree");
	printf("\nm1*ddy1/ddt + K1*y1      + K2*(y1-y2) = 0");
	printf("\nm2*ddy2/ddt + K2*(y2-y1) + K3*(y2-y3) = 0");
	printf("\n EEEEEEEEEEEEEEEEEE");
	printf("\nmk*ddyk/ddt + Kk*(yk-y(k-1)) + Kk*(yk-y(k+1)) = F*sin(f*t)");
	printf("\n EEEEEEEEEEEEEEEEEE");
	printf("\nmn*ddyn/ddt + Kn*(yn-y(n-1)) + K(n+1)*yn = 0\n");

    printf("\n(1) Rxݒ");
    printf("\n(2) n̒萔ݒ");
    printf("\n(3) `UȐ̐ݒ");
    printf("\n(4) `g̐ݒ");
    printf("\n(5) O͏ݒ");
	printf("\n(6) ݒ\n");

	printf("\n(1) Rx nfree(20) L[ =");
	scanf("%d", &nfree);
	if(nfree>NFREE) { printf("\nN=%d>%d  蒼",nfree,NFREE);  goto d1; }

//---------- e}XE΂ˁE_p[萔 ----------------------------//
d2:
	printf("\n(2) }X@m1 m2 ... mn [kg]@ L[ \n");
	for(i=0;i<nfree;i++)
	{  printf("No.%d  ",i+1);	scanf("%lf", &mass[i]);  }

	printf("\n΂˒萔 K1 K2 ... Kn+1[N/m]@L[ \n");
	for(i=0;i<=nfree;i++)
	{  printf("K%d=",i+1);	scanf("%lf", &Kspring[i]);  }
	printf("\n\n_p[H@yes:1   no:0 L[ dampsign=");
	dampsign = getch();
	if(dampsign=='1') 
	{   printf("\nW1,2,...,n[N/(m/s)]@L[\n");
	    for(i=0;i<=nfree;i++)
		{   printf("%d=",i+1); scanf("%lf",&lamda[i]); }
	}

	//------- Ȃ̌ŗLUvZom[] --------------------//
	freq();            //tsɂŗLUvZ
	//------- Ȃ̌ŗLU[h amode[][]vZ ----------//
	mode();            //U[ȟvZ
d3:
	//------- `悷ȐEg̐ ----------------//
	printf("\n(3) {̐UȐ`悷H  nc(%d)=",nfree);
	scanf("%d",&nc);  if(nc>nfree)  goto d3;
d4:
	printf("\n\n(4) (1`nf)Ԗڂ̃}X̎gȐ`H@nf=");
	scanf("%d",&nf);  if(nf>nfree)  goto d4;

d5:
	printf("\n%d̌Ȃ̌ŗLU 0[rad/s]=\n(",nfree);
	for(i=0;i<nfree;i++) { printf(" %7.4f",om[i]); if((i+1)/6*6==i+1) printf("\n "); }
	printf(")\n");
    //--------- U̐UForceCUomfC쓮}Xԍkforce -------------//
	printf("\n(5) U̐UF[N]EU[rad/s]E쓮}Xԍk(1,2,..) L[");
	printf("\n   F f k=");	scanf("\n%lf %lf %d",&Force, &omf, &kforce);  kforce--;
	for(i=0;i<nfree;i++) FM[i] = 0;   FM[kforce] = Force;

	//------- g(K)̌vZaseries0,1[i][k] -------------------------------//
	//         @i:}Xԍ(0 - nfree)Ck:(0 - mf)
	//           ÓForce*sin(f*t)ɑ΂鐳K
	//           nf : ɕ`悷Ȑ̖{
	//           wf : `̍݁Cmf : `_Cdom : g
	//---------------------------------------------------------------------------------//
	for(i=0;i<nf;i++) wa[i] = 0.5;           //`̏c{
	wf = 0.0025;                             //̍
	wmf = 1.0/wf;                             //`̓_
    mf  = 400;
	dom = om[nfree-1]/mf + 0.005;            //U̍݁őŗLU/mf+0.005
	momf = omf/dom;                          //O͐U̔ԍ
	for(i=0;i<=mf;i++)
		{   omx = i*dom;                     //őŗLUE[
	        fresponse0(omx, Amp);    //Ȃ̎g
			for(k=0;k<nfree;k++) aseries0[k][i] = Amp[k];
			if(dampsign=='1')
			{   fresponse1(omx, XR, YI, Amp, PHI);  //̎g
			    for(k=0;k<nfree;k++) aseries1[k][i] = Amp[k];
			}
	}
	if(dampsign!='1')   fresponse0(omf, Amp);
	else                fresponse1(omf, XR, YI, Amp, PHI);

d6:
	printf("\nO͐Uf=%7.4f(rad/s)̂Ƃ̒U̐UAmp[]=",omf);
	printf("\n(");  for(i=0;i<nfree;i++) printf(" %6.3f",Amp[i]);   printf(")");
	printf("\nȂ̐U[h");
	for(i=0;i<nfree;i++)
	{  printf("\n%d[h ",i+1);
	   printf("\n (");
	   for(k=0;k<nfree;k++) { printf(" %7.4f",amode[i][k]); if((k+1)/8*8==k+1) printf("\n  "); }
	   printf(")");
	}
    //---------------------- yy0[], vv0[] --------------------------------//
	printf("\n\n(6) ݒ");
	printf("\n@ŗL[hFa@f̒UFb  Î~ԁFc  ʐݒFd  ");
	k = getch();
	if(k=='a')
	{   printf("\nԖڂ̃[h(k=1,2,...)H k=");
	    scanf("%d",&k);  k--;
		for(i=0;i<nfree;i++) { yy0[i] = 0;  vv0[i] = amode[k][i]; }
	}
	if(k=='b')
	{   printf("\nU[hƂ");
		if(dampsign=='1') for(i=0;i<nfree;i++) { yy0[i] = YI[i];  vv0[i] = omf*XR[i];  }
		if(dampsign!='1') for(i=0;i<nfree;i++) { yy0[i] = 0;            vv0[i] = omf*Amp[i]; }
		printf("\nψ(");  for(i=0;i<nfree;i++)
		{ printf(" %6.3f",yy0[i]); if((i+1)/10*10==i+1) printf("\n     "); }  printf(")");
	    printf("\nx(");  for(i=0;i<nfree;i++)
		{ printf(" %6.3f",vv0[i]); if((i+1)/10*10==i+1) printf("\n     "); }  printf(")");
	}
	if(k=='c')    for(i=0;i<nfree;i++)  yy0[i] = vv0[i] = 0;
	if(k=='d') 
	{	printf("\nL[́@(y01 v01) (y02 v02) .... (m) (m/s) = \n");
	    for(i=0;i<nfree;i++)
		{  printf("y%d v%d[0]=",i+1,i+1);	scanf("%lf %lf", &yy0[i],&vv0[i]);  }
	}

	printf("\n\n's'L[ŁFU`p        'X' 'x'L[ŁFggk");
	printf("\n'n'L[ŁFRxύX        'Y' 'y'L[ŁFcgk");
	printf("\n'm'L[ŁF}X΂˒萔ύX    'T' 't'L[ŁFUȐԎύX");
	printf("\n'g'L[ŁFO͏ύX        'f'L[    Fg\");
	printf("\n'j'L[ŁFύX");
	printf("\nESCL[ŁFI\n");

    t = 0;
	for(i=0;i<nfree;i++) {	yy2[2*i]   = yy0[i];
	                        yy2[2*i+1] = vv0[i]; }
	mc = 0;                         //UȐ̉_̐
	r0[0] = 0.01;  r0[1] = 0;       //}XU}_
	wt = 0.004;                     //UȐԍ
	for(i=0;i<nc;i++)  wy[i] = 0.5; //e}XUEUȐ̏c{
	rc[0] = -0.99;  rc[1] = 0;      //UȐ_
    rf[0] = r0[0]; rf[1] = r0[1];   //g}_

}
/********** dialogue() end ******************************************************/

/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("nDOFU@L[n:Rx, m:}X΂ g:O j: ύXCf:g\, s:Up");

}

/******* usrdisplay() ************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	int     i, k;
	double  r1[2]; 

	usrSetting();

    //------- ̉DPݖɏo --------//
	for(k=0;k<nrkg;k++)
	{
	    for(i=0;i<2*nfree;i++)	yy1[i] = yy2[i];
	    rkg1( t, dt, yy1, yy2, 2*nfree);
		t = t + dt;
	}

	//---}X̐U}` r0:_, nfree:}X̐Cwy:U{, ya[]:U ------//
	for(i=0;i<nfree;i++)  ya[i] = yy2[2*i];
	drawfigure(r0, wy[0], nfree, ya );                      //U}X`
	//-----------------O͂ŕ\ ----------------------------------------//
	arrowl = 0.3*sin(omf*t)*wy[0];   alpha = PAI/2; arrowd = 0.04;
	if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	arrowl = fabs(arrowl);  
    arrow0[0] = r0[0] + (kforce+1)*(xedge - r0[0])/(nfree+1);  //̐[}X̏㉺0.04̈ʒu
	arrow0[1] = r0[1] + yy2[2*kforce]*wy[0] - arrowd;
	usrDrawArrow2d( arrow0, arrowl, alpha, blue ); 

	//---Ȑ` r0:_Cwt:ԍ݁Cwy[]:c{Cnc{ȐCmc̓_CUa[i][k] --//
    drawcharacter(-0.95, 0.9, H18,"curve color corresponds to mass number");
    drawcharacter(-0.95, 0.85, H18,"1grid=(1s, 0.2m)");
    drawcharacter(-0.95, -0.85, H18,"external force F(t)  1grid=0.5N");
	mc++;  if( mc > 1.0/wt ) mc = 0;
	fseries[mc] = Force*sin(omf*t);
	for(i=0;i<nc;i++)	yseries[i][mc] = yy2[2*i];
	usrDrawAxis2d( rc, 0.0 );
	r1[0] = r0[0] - 30*wt/(nrkg*dt);  r1[1] = r0[1];
    usrGrating( r1, 0, 30, wt/(nrkg*dt), 0.2*wy[0] );
	drawcurven( rc, wt, wy, nc, mc, yseries, MMAX );         //UȐ
	r1[0] = rc[0];   r1[1] = rc[1] - 0.5;
	drawcurve1( r1, wt, 0.2, mc, fseries, blue );            //O͋Ȑ
//void drawcurven( double r0[], double wx, double wy[], int n, int m, double *a, int mmax )

	//--------- KEY='f'̂Ƃ͏LU}ɏd˂ĎgȐ` ----------//
    if(KEY=='f' || KEY=='x' || KEY=='X' ||KEY=='y' || KEY=='Y')
	{
	//-----g`iP-nf}X̉j-------------------------------//
	//-----rf[]_Cwfg݁Cwac{Cnf{̋ȐCmf̓_Caseries0,1[][]
       drawcharacter(0.05, 0.9, H18,"curve color corresponds to mass number");
       drawcharacter(0.05, 0.85, H18,"blue points show forced vibration amplitude");
       if(dampsign=='0')      //Ȃ̉Ȑ`
	   drawcurven(rf, wf, wa, nf, mf, aseries0, MMAX);
       if(dampsign=='1')      //̉Ȑ`
	   drawcurven(rf, wf, wa, nf, mf, aseries1, MMAX);
	   r1[0] = rf[0] + momf*wf;
	   if(dampsign=='0')  for(i=0;i<nf;i++)
	   {  r1[1] = rf[1] + aseries0[i][momf]*wa[0];
   	      usrDrawSolidCircle2d(r1, 0.01, blue);  }
	   if(dampsign=='1')  for(i=0;i<nf;i++)
	   {  r1[1] = rf[1] + aseries1[i][momf]*wa[0];
   	      usrDrawSolidCircle2d(r1, 0.01, blue);  }
	}
	usrFlushAndSwap();
}
/******* usrdisplay() end ***************************************************/

/******* usrkeyboard() ******************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	int  i;

    KEY = key;
	if(key=='y' || key=='Y')         //c{ύX
	{
		if(key=='y') {	for(i=0;i<nfree;i++) wy[i] = 0.9*wy[i];
		                for(i=0;i<nfree;i++) wa[i] = 0.9*wa[i]; }
		if(key=='Y') {	for(i=0;i<nfree;i++) wy[i] = wy[i]/0.9;
		                for(i=0;i<nfree;i++) wa[i] = wa[i]/0.9; }
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')         //XyNgݕύX
	{
		if(key=='t')	wt = 0.9*wt;
		if(key=='T')	wt = wt/0.9;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='x' || key=='X')         //XyNgݕύX
	{
		if(key=='x')	wf = 0.9*wf;
		if(key=='X')	wf = wf/0.9;
		wmf = 1.0/wf;
		if(wmf>mf)  wmf = mf;
		MotionSign = 0;		usrdisplay();
		goto end;
	}
	if(key=='f' || key=='s')         //Ԑi߂Ef`̗L
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='n' || key=='m' || key=='g' || key=='j') //RxE}X΂ˁEÓEύX
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}
/******* usrkeyboard() end *************************************************/


void motion_function(void){ }
