/* spectrum2.c vibfunc.h graph2d.h                              2005.9.7  */
/*@g`̃XyNg͂Ɣg`                                  */
/*Eg`XyNg͂CLXyNgɂg`s      */
/*EȂXyNgɂg`g`cނƂ              */
/*E͂g`̓j[IԂC̃t@CI        */
/*Ej[ɂ(1)wg,(2)Ug,(3)`pX,(4)OppX   */
/*                                                                  */
/*Et@Cfile="nperioddata1,2,.."ƂClf[^ׂ݂̂  */
/*Eg`CXyNgCLXyNgɂ鍇g`}            */
/*EFourier(fn,n,m,Fc,Fs):fn[0-n], Fc,Fs[0-m], n<1001:even number, m<=n/2 */
/*Eyy=ift(Fc,Fs,M,yy,n,k) : Fc,Fs[0-M], yy[k], total data n              */
/* fn[] : non-periodical wave data                                        */
/* Fc[],Fs[] : spectrum cos, sin                                          */
/**************************************************************************/

#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/****************************************************************************/
//       mainŒ`Cvibfunc.hŎg֐                                  //
/****************************************************************************/
double f(int i, double t, double y[]) {return (0);}
/****************************************************************************/

/***************************************************************************/
//       vibfunc.hŒ`CmainŎg֐                                 //
/*************************************************** 2005.9.05 *************/
// vibfunc.h   UV~[^̂߂̊֐Q                              //
//  (1) rkg(t,dt,z0,z4,n) : Runge-Kutta-Gill@ɂ̉         //
//  (2) det=imatrx(n, *a, nmax) : ts)ƍs񎮂̒l                        //
//  (3) Fourier(f[], n, m, Fc[], Fs[]) : Fourierϊ(FourierWJj     //
//  (4) InvFourier(Fc[], Fs[], m, n, f[]) : Fouriertϊ                  //
//  (6) drawfigure(r0[], n, a[]) : nRxUȔuԐ}                 //
//  (7) drawcurve(r0[], wx, wy, n, m, *a, mmax) : n{̐UȐ`        //
//  (8) drawcurve1(r0[], wx, wy, m, *a, mmax)   : (X,Y)ʏ̔CӋȐ`//
//  (9) drawbargraph(r0[], wx, wy, m, a[]) : _Ot`                  //
//  (10) drawfreqcurve()
/***************************************************************************/




/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          601
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

static double eta, zeta, T, t, dt;   //ŁCāCf[^ԁCԍ
double        OM, dom;         //=2/T, d=2/dt
static double r0[2], rc[2], rf[2], rh[2], rh1[2], rg[2];    //e}̌_
static double r1[2], r2[2];
static double fn[MMAX], fsyn[MMAX];    //g`Cg`
static double Fc[MMAX], Fs[MMAX], F[MMAX];     //XyNg(cos,sin)CXyNg̐U
static double yseries[10][MMAX];     //Ȑ`̕f[^
static int    nmax, mmax;            //FourierWJf[^EXyNg
static int    nt;                    //g`ݐ(=1/wtj
static int    msyn, msynn[10];       //g`̃XyNg
static int    gcnt;                  //g`̐
static double wt, wy, wyn[10];       //ψʁExȐ̉݁Ec{
static int    mf=250, nf=1;          //Pg̉ݐCȐ
static double wf=0.02, wa;           //PgȐ̉݁Ec{
static int    m, n;
static double yy;                    //fileǂݍރf[^
static double th1;                   //Ώ̋`g̕(deg)
static int    MotionSign;
unsigned char h, sgn, KEY, KEY1;
FILE*fp;   char fname[32];
void   dialogue();
//double xedge=0.99;
/**************************************************************************/
//       g`e                                                   //
// (1)  wIg`iPxn̉j
// (2)  Ug`iQxn̉j
// (3)  `pX
// (4)  OppX
/**************************************************************************/
/******** (1) wIg fn=exp(-t) *******************/
void exponent(int n, double dt, double eta)
  {
	static    int i;
	static double t;

    for(i=0;i<=n;i++)
	{ t = i*dt;  fn[i]=exp(-eta*t); }
  }
/******** (2) U2 fn=exp(-t)*cos(t) ******************************/
void dampedvibc(int n, double dt, double zeta)
  {
	static int i;
	static double t;

    for(i=0;i<=n;i++)  
	{ t = i*dt;  fn[i]=exp(-zeta*t)*cos(t); }
  }
/******** (3) U3 QxñCpX **************************/
//            fn=exp(-t)*(1/(1-^2))*sin((1-^2)*t)   (<1)        //
//            fn=exp(-t)*(1/(^2-1))*sinh((^2-1)*t)  (>1)        //
//            fn=exp(-t)*t                                  (=1)        //
/****************************************************************************/
void dampedvibs(int n, double dt, double zeta)
  {
	static int i;
	static double t, OM;

	if(zeta<1)
	{
		OM = sqrt(1 - zeta*zeta);
        for(i=0;i<=n;i++)  
		{ t = i*dt;  fn[i] = exp(-zeta*t)*sin(OM*t)/OM; }
	}
	if(zeta>1)
	{
		OM = sqrt(zeta*zeta - 1);
        for(i=0;i<=n;i++)  
		{ t = i*dt;  fn[i] = exp(-zeta*t)*sinh(OM*t)/OM; }
	}
	if(zeta==1)
	{
        for(i=0;i<=n;i++)  
		{ t = i*dt;  fn[i] = exp(-t)*t; }
	}
  }
/********* (4) `pX fn=1(0<t<T), =0(T<1) ******************************/
void steppulse(int n, double dt, double T)
  {
	static int i, N;
	static double t;

	N = T/dt;
    for(i=0;i<N;i++ ) fn[i] = 1;
	for(i=N;i<=n;i++) fn[i] = 0;
  }
/***** (5) OppX fn=z(0<t<T/2), =z(T/2<t<T), =0(T<t<1) ******/
void tripulse(int n, double dt, double T)
  {
	static int i, M, N;
	static double t;

	M = T/(2*dt);
	N = 2*M;
    for(i=0;i<M;i++) 	fn[i] = (double)i/(double)M;
    for(i=M;i<N;i++) 	fn[i] = ((double)N-i)/(double)M;
	for(i=N;i<n;i++)    fn[i] = 0;
  }
/**********@g`e@I ******************************************/




/************************************************************************************/
int main(int argc, char *argv[])
{
	KEY = 'm';
	dialogue();

	DrawGL(&argc, argv);
}
/********* main() end ***********************************************************/

/*************** dialogue() *****************************************************/
void dialogue(void)
{
	static int i, j, k;

	if(KEY=='m')  goto d1;      //VȔg`I
	if(KEY=='n')  goto d2;      //g`̃XyNgύX
d1:
    printf("\ng`̃XyNg͂ƗLXyNgɂg`");
	printf("\ng`ŃXyNgȂƔg`ČcނƂ\n");
	printf("\n(1) g`I");
	printf("\n(2) g`iFouriertϊĵ߂̗pXyNgݒ\n");
	printf("\n(1) g`j[C܂͎̃t@CI");
	printf("\n    t@Cfile=""y(t)data1,2,...""Ƃ");
    printf("\n    g`f[^Fj[ 1 or t@C 0 ?  ");
    h=getch(); if(h=='1') goto p2;

	//-------- file="perioddata"f[^ǂݍ ---------------//
	printf("\n\nfile y(t)data1, y(t)data1,...ƂD");
	printf("\nlf[^̂.@***\n ....  (f[^fileɂ͕sv)");
    printf("\n\nInput filename="); scanf("%s",fname);
    fp=fopen(fname,"rt");
    nmax=0;
    while(fscanf(fp,"%lf\n",&yy)==1)
	{ fn[nmax]=yy; nmax++;if(nmax>500) break; }
    fclose(fp);

	if(nmax>MMAX-1) { printf("\nn=%d>MAX=%d. f[^ł؂ n=%d",nmax,MMAX-1,MMAX-1);
	                  nmax = MMAX-1; }
	mmax = nmax/2;
    wt = 1.0/nmax;
    printf("f[^nmax=%d\n",nmax);
    goto p3;

	//----------- j[g`Iԁfn[] ------------------------//
p2:
   printf("\n\nwg:2  U1:3  U2:4  `pX:5  OppX:6 ");
   h=getch();
   nmax = 500;                //f[^
   mmax = nmax/2;             //XyNg
   dt = 0.1;                  //vZ̎ԍ(T=nmax*dt=50s)
   dom = 2*PAI/(nmax*dt);     //vZ̐Ud=2/T=0.1256[rad/s]=0.02[Hz]
   OM = mmax*dom;             //őU=mmax*d=31.4[rad/s]=5[Hz]
   //--------------- wIg --------------------------------------------//
   if(h=='2') { printf("\ny(t)=exp(-t)  Input =");   scanf("%lf",&eta);
                exponent( nmax, dt, eta );  T = nmax*dt; }
   //--------------- ]Ug ------------------------------------------//
   if(h=='3') { printf("\ny(t)=exp(-t)*cos(t)  Input (<1)=");   scanf("%lf",&zeta);
                dampedvibc( nmax, dt, zeta );  T = nmax*dt; }
   //--------------- Ug ------------------------------------------//
   if(h=='4') { printf("\ny(t)=exp(-t)*sin(t)/,  =(1-^2)  (<1)");
                printf("\n    =exp(-t)*sinh(t)/, =(^2-1)  (>1)");
				printf("\n    =exp(-t)*t,                           (=1)");
                printf("\n   Input =");  scanf("%lf",&zeta);
                dampedvibs( nmax, dt, zeta );  T = nmax*dt; }
   //--------------- `gpX --------------------------------------------// 
   if(h=='5') { printf("\ny(t)=1 (t<T)");
                printf("\n    =0 (T<t<50s)");
                printf("\n   Input pulsewidth T[s]=");  scanf("%lf",&T);
                steppulse( nmax, dt, T );  }
   //--------------- OppX ----------------------------------------------//
   if(h=='6') { printf("\ny(t)= z (t<T/2)");
                printf("\n    = z (T/2<t<T)");
				printf("\n    = 0      (T<t<50s)");
                printf("\n   Input pulse width T=");  scanf("%lf",&T);
                tripulse( nmax, dt, T );  }

p3:
   //-------------- g`̃XyNg ------------------------------------//
   FourierT( fn, dt, nmax, mmax, Fc, Fs);
   for(i=0;i<=mmax;i++) F[i] = sqrt( Fc[i]*Fc[i] + Fs[i]*Fs[i] );
   gcnt = 0;     //g`̏

   //---------- g`ŗpXyNg̐msyn -------------------//
d2:
   printf("\n\n f[^nmax=%d    g`̂߂̗pXyNgw",nmax);
   printf("\n(2) pXyNg msyn(<=%d)=",nmax/2); scanf("%d",&msyn);

   //---------- g`(msyn̃XyNgCnmax̃f[^fsyn[]) -----//
   InvFourierT(fsyn, dom, nmax, msyn, Fc, Fs);
   //---------- g`yseries[gcnt][] ----------//
   for(i=0;i<=nmax;i++)  yseries[gcnt][i] = fsyn[i];
   msynn[gcnt] = msyn; 
   gcnt++;

   //----------- L[ɂύX ---------------------//
    printf("\n'm'L[ŁFg`I");
	printf("\n'n'L[ŁFg`ɎgXyNgύX");
	printf("\n'f'L[ŁFg`ƃXyNĝݕ`");
	printf("\n'X' or 'x'L[ŁFXyNg̉gk");
	printf("\n'Y' or 'y'L[ŁFXyNg̏cgk");
	printf("\n'T' or 't'L[ŁFg`̎Ԏgk");
	printf("\nESCL[ŁFI\n");

   //------- `̌_ʒuE݁Eg嗦̏ݒ ----//
	wt = 1.0/nmax;                      //`掞ԍ=0.002s
	wy = 0.5;
	for(i=0;i<10;i++) wyn[i] = wy;      //g`c{
	nt = nmax;
	r0[0] = -0.99;  r0[1] = 0;          //g``挴_
	rc[0] = r0[0];  rc[1] = r0[1]-0.3;  //Eg``挴_
	//------ XyNg(0ԖڐU=0.5ɕ`) -------//
	wf = 0.01;                          //`U
	mf = mmax;                          //U
	wa = 0.5/F[0];                      //c{
	wa = wy;                            //c{
	rf[0] = rc[0] + 1.0; rf[1] = rc[1]; //XyNg_

}
/************ dialogue() end ***********************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("g`́̕E  m:g`ICn:pXyNgύX, f:XyNgCh:g``");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//---XyNg`Frf[]_Cwfg݁Cwac{-----------------------//
    drawcharacter(-0.01, 0.95, H18, "bargraph : spectrum |Y(jom)|");
    drawcharacter(-0.01, 0.90, H18, "blue point : spectrum number m");
    drawcharacter(0.23, 0.85, H18, "for wave composition");
    drawcharacter(-0.01, 0.80, H18, "1grid = (0.2Hz,0.2[m/(rad/s)]), df=0.02,fmax=5[Hz]");
		r1[0] = rf[0];        r1[1] = rf[1];
		r2[0] = rf[0]+1.0;    r2[1] = rf[1];
        usrDrawLine2d(r1, r2, red);        //
		for(i=0;i<gcnt;i++)
		{	r1[0] = rf[0]+msynn[i]*wf;        r1[1] = rf[1];
            usrDrawSolidCircle2d(r1, 0.008, blue);
		}
		r1[0] = rf[0]+300*wf;        r1[1] = rf[1]+6*wa;
        usrGrating( r1, 0.0, 30, 10*wf, 0.2*wa );
        //------ XyNg} --------------------------//
		drawbargraph(rf, wf,  wa,  mmax, F);

	//--- g``Fr0[]_CwtԎCwy[]c{Cn{ȐCm̓_CUa[i][k]
    drawcharacter(-0.95, 0.95, H18, "blue : original wave y(t)");
    drawcharacter(-0.95, 0.90, H18, "red  : composed wave y(t)");
    drawcharacter(-0.95, 0.85, H18, "tmax=50s");
	usrDrawAxis2d( rc, 0.0 );
	r1[0] = rc[0];    r1[1] = rc[1]; 
    usrGrating( rc, 0.0, 10, 0.1, 0.2*wy );    //ԎPڂTbCcP0.2m
	drawcurve1( rc, wt, wy, nt, fn, blue );
    //------ g`g`ɏd˕` ----------------------//
//void drawcurven( double r0[], double wx, double wy[], int n, int m, double *a, int mmax )
	drawcurven( rc, wt, wyn, gcnt, nt, yseries, MMAX);
	rh1[0] = rc[0];   rh1[1] = rc[1]+0.3;
	drawcurve1( rh1, wt, wy, nt, fn, blue );
	drawcurve1( rh1, wt, wy, nt, fsyn, red );

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/

/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	KEY1 = KEY;
	KEY = key;

	if(key=='m' || key=='n')              //g`ICg`̃XyNgύX
	{
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='x' || key=='X')                          //XyNggk
	{
		if(key=='X')  wf = wf/0.9;
		if(key=='x')  wf = 0.9*wf;
		KEY = KEY1;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='y' || key=='Y')                          //XyNgcgk
	{
		if(key=='Y')  wa = wa/0.9;
		if(key=='y')  wa = 0.9*wa;
		KEY = KEY1;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')                          //XyNgcgk
	{
		if(key=='T')  wt = wt/0.9;
		if(key=='t')  wt = 0.9*wt;
		nt = 1/wt;
		if(nt>nmax)  nt = nmax;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}

void motion_function(void){ }
