/************************************************************* 2005.9.26 *****/
//  ForcedVanderPol.c : PRxn̋UiKj                   //
//  E ddy/ddt - (1-y^2)*dy/dt + y = F*sin(z*t)                            //
//@E (1)  ݒ    (2) ݒ                                       //
//@E`ʍFUȐC@EFgCEFU}@\       //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          801
#define   TEN           10
#define   TWEN          20

#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

float  ffred[]   ={0.1, 0.0, 0.0, 0.5};
static double eps, eps1;             //̌
static double ylimit;                //ÜE
static double a, t, dt=0.02;
static double Force, Force1, z;      //O͐UCO͐U
static double Amps, Ampd, fai;       //Ý(m)CU(m)Cʑx(rad)
static double yy0, vv0, yy1[2], yy2[2], yseries[3][MMAX];
static double YY[5];                 //w肵ẑƂ̐U
static int    IZ;                    //w肵ẑƂ̉̐
static double FY[MMAX];              //퉞̃XyNg
static double aseries0[MMAX][3];     //w肵,F̎g
 double as0[TEN][3], as[TWEN][TEN][3];  //ĕςg[0,1]Đڋ߂Ăl
 double aseries[TWEN][MMAX][3];         //ĕςg
 double bs0[TEN][3], bs[TWEN][TEN][3];  //Fςg[0,1]Đڋ߂Ăl
 double bseries[TWEN][MMAX][3];         //Fςg
static int    my, nf;                //g̏cݐCȐ
static int    nny0;                   //as0[][0,1]̍Đڋ߂̐
static int    nny[TWEN];              //as[][][0,1]̍Đڋ߂̐
static int    nvib, ncurve;          //`悷U}̃}X̐CUȐ̐
static int    nrkg=5;                //rkg()nrkgJԂlf[^Ƃ
static double r0[2], rc[2], rf[2];   //`挴_
static double r1[2], r2[2];
static double wt, wy[2];             //ψʁExȐ̏c{
static double dy, wa, wz;            //nf{̎gȐ̏c݁Ec{E{
static double RF[2], WF, WA;         //g`XyNg}̌_E݁Ec{
static double arrow0[2], arrowl, alpha, arrowd;
static double transx, transy, rot;
static int    m, mm, n;              //g`̃f[^Eőf[^
static int    nsp;                   //g`XyNg
static int    sgnf;                  //Éoreς̂\I
static int    MotionSign;
unsigned char KEY;
void   rkg();
void   dialogue();
static double eps0[]={0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1.0, 2.0, 5.0, 10.0};
static double FF0[] ={0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1.0, 2.0, 5.0, 10.0};
//double xedge=0.99;



/************** ̉ *********************************************/
double f(int i, double t, double y[])
{
   static double  yy, Fex;
   if(i==0) yy=y[1];
   if(i==1) 
   {
	   Fex = Force*sin(z*t);                     //O
	   yy  = Fex + eps*(1 - y[0]*y[0])*y[1] - y[0];
  }
   return yy;
}
/************* f() end *******************************************************/

/************* ǧvZ **********************************************/
//     U^ĐUvZ                                            //
//     wy݂ŁC0-m܂ł̐UɂāCUvZ                       //
//     ʂfy[][0,1]ւQ̐UCfy[][2]֐U                //
//     [0,1]Őڋ߂Ăfyn[n][]                                   //
//     z̉ȂƂfy[0,1]=-1ƂD                                   //
//     ̐őMMAX                                                        //
//     (f,y)ƂKĂ                                               //
/*****************************************************************************/
void freqcharct(double wy, int m, double fy[MMAX][3], int *nn, double fyn[TEN][3])
{
	static double y, yy, eps2, F2, rou, B, C, D, zz0, zz1, wyy, ff[TEN][3];
	static int    i, j, kd, id, n;

	F2 = Force*Force;
	eps2 = eps*eps;
	fy[0][0] = 100; fy[0][1] = -1;   fy[0][2] = 0;
	n = 0;
	kd = 0;        //uvuȂv֑JڂƂk=0,Ȃ܂k=1
	for(i=1;i<=m;i++)
	{
		y = i*wy;
		yy = y*y;
		rou = yy/4;
		B = 1 - eps2/2*(1 - rou)*(1 - rou);
//		C = 1 - Force*Force/(eps*yy);
		C = 1 - F2/yy;
		D = B*B -C;
		//--------- (1)uv̎Ɂuv̏ꍇ ----------------------//
		if(kd==0 && D>=0)
		{
			kd = 0;          //TC
		    D = sqrt(D);
		    zz0 = B + D;   if(zz0>0)  fy[i][0] = sqrt(zz0);
		                   else       fy[i][0] = -1;
		    zz1 = B - D;   if(zz1>0)  fy[i][1] = sqrt(zz1);
		                   else       fy[i][1] = -1;
		    fy[i][2] = y;
			goto f2;
		}
		//------ (2)uv̎ɁuȂv̏ꍇ -------------------------//
		//--------- ȂȂ钼O(k=0,D<0)y܂vZ -----------//
		if(kd==0 && D<0)
		{   
			id= i;
		    y = y - wy;
		    wyy = 0.1*wy;
			for(i=id;i<id+TEN;i++)
			{
		       y = y + wyy;
	    	   yy = y*y;
		       rou = yy/4;
    		   B = 1 - eps2/2*(1 - rou)*(1 - rou);
	           C = 1 - F2/yy;
		       D = B*B -C;
			   if(D>=0)
			   {
 		          D = sqrt(D);
		          zz0 = B + D;   if(zz0>0)  fy[i][0] = sqrt(zz0);
		                         else       fy[i][0] = -1;
		          zz1 = B - D;   if(zz1>0)  fy[i][1] = sqrt(zz1);
		                         else       fy[i][1] = -1;
		          fy[i][2] = y;
                  kd = 0;
			   }
			   //-------- ȂȂ钼Ỏfyn[] -----//
		       if(D<0)
			   {
				   if(fy[i-1][0]>0 && fy[i-1][1]>0)
				   {   fyn[n][0] = fy[i-1][0];
				       fyn[n][1] = fy[i-1][1];
     		           fyn[n][2] = y;
				       n++;
				   }
/*
printf("\nfreqcharact() (2) eps=%5.2f",eps);
printf("\ni-2=%3d  fy[0,1,2] =(%7.4f %7.4f %7.4f)"
	   ,i-2,fy[i-2][0],fy[i-2][1],fy[i-2][2]);
printf("\ni-1=%3d  fy[0,1,2] =(%7.4f %7.4f %7.4f)"
	   ,i-1,fy[i-1][0],fy[i-1][1],fy[i-1][2]);
printf("\nn  =%3d  fyn[0,1,2]=(%7.4f %7.4f %7.4f)"
	   ,n-1,fyn[n-1][0],fyn[n-1][1],fyn[n-1][2]);
getch();
*/

				   fy[i][0]= fy[i][1] = -1;    fy[i][2] = y;
				   kd = 1;  break;
			   }
			}
			goto f2;
		}
		//-------- (3)uȂv̎Ɂuv̏ꍇ ------------------//
		//--------   钼O(k=1,D>0)y܂vZ -------//
		if(kd==1 && D>0)
		{   
			id= i;          //JڂƂ̔ԍL
		    wyy = 0.1*wy;
			for(j=0;j<10;j++)
			{
		       y = y - wyy;
	    	   yy = y*y;
		       rou = yy/4;
    		   B = 1 - eps2/2*(1 - rou)*(1 - rou);
	           C = 1 - F2/yy;
		       D = B*B -C;
			   if(D>=0)
			   {
 		          D = sqrt(D);
		          zz0 = B + D;   if(zz0>0)  ff[j][0] = sqrt(zz0);
		                         else       ff[j][0] = -1;
		          zz1 = B - D;   if(zz1>0)  ff[j][1] = sqrt(zz1);
		                         else       ff[j][1] = -1;
		          ff[j][2] = y;
			   }
			   //-------- ȂȂ钼Ỏfyn[] -----//
		       if(D<0)
			   {
				   if(ff[j-1][0]>0 && ff[j-1][1]>0)
				   {   fyn[n][0] = ff[j-1][0];
				       fyn[n][1] = ff[j-1][1];
     		           fyn[n][2] = y;
				       n++;
				   }
/*
printf("\nfreqcharact() (3) eps=%5.2f",eps);
printf("\nj-1=%3d  ff[0,1,2] =(%7.4f %7.4f %7.4f)"
	   ,j-1,ff[j-1][0],ff[j-1][1],ff[j-1][2]);
printf("\nj-1=%3d  ff[0,1,2] =(%7.4f %7.4f %7.4f)"
	   ,j-1,ff[j-1][0],ff[j-1][1],ff[j-1][2]);
printf("\nn  =%3d  fyn[0,1,2]=(%7.4f %7.4f %7.4f)"
	   ,n-1,fyn[n-1][0],fyn[n-1][1],fyn[n-1][2]);
getch();
*/
				   break;
			   }
			}
			//---------- ff[][]tɂfy[][] ----------------//

//printf("\n(3) fy[%d][]=(%7.4f %7.4f %7.4f)"
//	,id-1,fy[id-1][0],fy[id-1][1],fy[id-1][2]);

			for(i=0;i<j;i++)
			{    fy[id+i][0] = ff[j-i-1][0];
			     fy[id+i][1] = ff[j-i-1][1];
			     fy[id+i][2] = ff[j-i-1][2];

//printf("\n    fy[%d][]=(%7.4f %7.4f %7.4f)"
//	,id+i,fy[id+i][0],fy[id+i][1],fy[id+i][2]);
			}
			i = id + j -1;
			kd = 0;          //́uvn߂
			goto f2;
		}

		//--------- (4)uȂv̎ɁuȂv̏ꍇ ---------------------//
		if(kd==1 && D<0) { fy[i][0]= fy[i][1] = -1; fy[i][2] = y; }

f2:;

/*
printf("\nfreqcharact()  eps=%5.2f",eps);
if(D>0)
printf("\ni=%3d  y=%7.4f  z*z[0,1]=(%7.4f %7.4f) z[0,1]=(%7.4f %7.4f)"
	   ,i,y,zz0,zz1,fy[i][0],fy[i][1]);
if(D<0)
printf("\ni=%3d  y=%7.4f  D=%7.4f z[0,1]=(%7.4f %7.4f)"
	   ,i,y,D,fy[i][0],fy[i][1]);
getch();
*/

	}

//printf("\nL̓=%5.2f\n",eps);
//getch();

        *nn = n;

}
/********* freqcharct() end ***************************************************/

/********* yz(z) **************************************************************/
//         sereis0[], as0[]zɑΉUT                          //
//    z       : U                                                      //
//    Y[]     : w肵ẑƂ̐U                                         //
//    id      : ̐i߂l)                                               //
/******************************************************************************/
int yz(double z, double Y[])
{
	static  int   i, id;
	static double diff0, diff1, ratio;

	id = 0;
	//--------- [0]niz傫jT ------------------------------//
	diff0 = aseries0[0][0] - z;
	for(i=1;i<my;i++)
	{
		diff1 = aseries0[i][0] - z;
		if(aseries0[i-1][0]>0 && aseries0[i][0]>0)
    	if(diff0*diff1<0)
		{
			ratio = diff1/(diff1 - diff0);
			Y[id] = aseries0[i][2] - ratio*(aseries0[i][2]-aseries0[i-1][2]);
			id++;
		}
	    diff0 = diff1;
	}
	//--------- [1]nizjT -------------------------------//
	diff0 = aseries0[0][1] - z;
	for(i=1;i<my;i++)
	{
		diff1 = aseries0[i][1] - z;
		if(aseries0[i-1][1]>0 && aseries0[i][1]>0)
		if(diff0*diff1<0)
		{
			ratio = diff1/(diff1 - diff0);
			Y[id] = aseries0[i][2] - ratio*(aseries0[i][2]-aseries0[i-1][2]);
			id++;
		}
	    diff0 = diff1;
	}
	//---------- as0[][]i[0][1]ȂꏊjT ---------//
	for(i=0;i<nny0;i++)
	{
		diff0 = as0[i][0] - z;
		diff1 = as0[i][1] - z;
		if(diff0*diff1<0) { Y[id] = as0[i][2];  id++; }
	}

	return id;
}
/************ yz() end ********************************************************/


/********** drawFVanderPol() **************************************************/
//    VanderPolnU̎g`
//    cas[i][2], aseries[i][0,1]̃f[^
//    f[^͏X؂Ă̂łȂĂ_񂾂`悷
//    rf[]   : W_
//    wz, wa : c̔{
//    my     : f[^
/*******************************************************************************/
void drawFVanderPol(double rf[], double wz, double wa, int my, double as[MMAX][3], float fcolor[])
{
	static int  i, i1[4], i2[4], I, j, k1, k2;
	static double r1[2], r2[2], y;

	k1 = k2 = 0;   //vuȂvɑJڂ

	//---------- [0]niz傫j̕` : n߂Pq̓_ ----//
	for(i=1;i<=my;i++)
	{
		if(as[i-1][0]>0 && as[i][0]>0) 
		{ r1[0] = rf[0] + wz*as[i-1][0];  r1[1] = rf[1] + wa*as[i-1][2];
		  r2[0] = rf[0] + wz*as[i][0];    r2[1] = rf[1] + wa*as[i][2];
	      usrDrawLine2d( r1, r2, fcolor );
		}
		if(as[i-1][0]>0 && as[i][0]<0)	{ i1[k1] = i-1;  k1++; }
		if(as[i-1][0]<0 && as[i][0]>0)	{ i2[k2] = i;   k2++;  }
	}

	//---------- [1]nizj̕` : rPq̓_ -----//
	k1 = k2 = 0;   //vuȂvɑJڂ
	for(i=1;i<=my;i++)
	{
		if(as[i-1][1]>0 && as[i][1]>0) 
		{ r1[0] = rf[0] + wz*as[i-1][1];  r1[1] = rf[1] + wa*as[i-1][2];
		  r2[0] = rf[0] + wz*as[i][1];    r2[1] = rf[1] + wa*as[i][2];
	      usrDrawLine2d( r1, r2, fcolor );
		}
		if(as[i-1][1]>0 && as[i][1]<0)	{ i1[k1] = i-1; k1++;  }
		if(as[i-1][1]<0 && as[i][1]>0)	{ i2[k2] = i;   k2++;  }
	}

    //----------- [0],[1]nƂ_ŌオlĂ[0],[1]Ȃ ----------//
	//----------- ʕȂ ------------------------------------//
	for(i=0;i<k1;i++)
	{
		I = i1[i];
	    if(I!=0 && as[I][0]>0 && as[I][1]>0)
		{ r1[0] = rf[0] + wz*as[I][0];  r1[1] = rf[1] + wa*as[I][2];
	      r2[0] = rf[0] + wz*as[I][1];  r2[1] = r1[1];
	      usrDrawLine2d(r1, r2, fcolor );
		}
	}

	//------------ ȂDi=0͏ -------------------------//
	for(i=1;i<k2;i++)
	{
		I = i2[i];
	    if(I!=0 && as[I][0]>0 && as[I][1]>0)
		{ r1[0] = rf[0] + wz*as[I][0];  r1[1] = rf[1] + wa*as[I][2];
	      r2[0] = rf[0] + wz*as[I][1];  r2[1] = r1[1];
	      usrDrawLine2d(r1, r2, fcolor );
		}
	}
}
/**************** drawFVanderPol() end **********************************************/

/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/




/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
int main(int argc, char *argv[])
{
	static int i, m, n;

	KEY = 'm';

	dialogue();
	DrawGL(&argc, argv);
}
/*************main() end ****************************************************/

/*********** dialogue() *****************************************************/
void dialogue(void)
{
	static int  i, k;

    if(KEY=='m')   goto d1;
    if(KEY=='f')   goto d2;
    if(KEY=='j')   goto d3;

d1:
	//---------------- n̒萔ݒ ---------------------------------------//
	printf("\nPRxUn(Van der Pol's equation)̋U̕`");
	printf("\nK@ddy/ddt - (1-y^y)*dy/dt + *y = F*sin(z*t)\n");
	printf("\nL[́@(1) ");
	printf("\n        @(2) āCz");
	printf("\n        @(3) ");

	printf("\n\n(1) ̌ÁCL[ =");	scanf("%lf", &eps);
	
d2:
	//----------------- O͏ݒ ---------------------------------------//
	printf("\n     z=1̕t߂ŁCO͐U̐Ui݌ہj");
	printf("\n     z=1𗣂ƁCIȐU͌Ȃ");
	printf("\n(2) O͐UF, O͐Uz@́@F z=");
	scanf("%lf %lf",&Force, &z);

	//-------- ݒ肵,Fł̎gvZ Udy݂őΉz߂ ----------//
	//--------- my:݂̐Caseries0[i][0,1]:zQʂC[i][2]:U -------------------//
	//--------- as0[i][0,1,2]:[0,1]nŐڋߒlz,U, nny0:Őڋߒl̐ -----------//
    dy = 0.005;  my = 800;
    freqcharct(dy, my, aseries0, &nny0, as0);        //w肵, FɂĂ̎g
    IZ = yz( z, YY);
	
	//-------- ݒ肵FƂ̃Âł̎gvZ Udy݂őΉz߂ ---//
	eps1 = eps;
	nf = 10;
	for(k=0;k<nf;k++)
	{
		eps = eps0[k];
        freqcharct(dy, my, aseries[k], &nny[k], as[k]);  //̃ĂɂĂ̎g
	}
	eps = eps1;
	ylimit = 1.41421356;     //Uȉ͕sc
	//-------- ݒ肵ÂƂ̂eł̎gvZ Udy݂őΉz߂ ---//
	Force1 = Force;
	nf = 10;
	for(k=0;k<nf;k++)
	{
		Force = FF0[k];
        freqcharct(dy, my, bseries[k], &nny[k], as[k]);  //̃ĂɂĂ̎g
	}
	Force = Force1;

d3:
	//---------------- ݒ -----------//
	printf("\n(3)   y0 v0 = ");
	scanf("%lf %lf",&yy0, &vv0);

	//--------------- L[͂ɂύX -----------//
    printf("\nUȐ`\@ԁF@΁FO\n");
	printf("\n's'L[ @FU`p             'Y' 'y'L[ŁFg̏c{");
	printf("\n'm'L[   FÕύX           'T' 't'L[ŁFUȐy(t)̎ԎLk");
	printf("\n'f'L[Ł@ FO F,z ύX            'E' 'e'L[ŁFF or Éςf\");
	printf("\n'j'L[   F y0,v0 ύX");
	printf("\nESCL[   FI\n");
//	getch();

	yy2[0] = yy0;
	yy2[1] = vv0;
    t = 0;
	m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = 0;

	r0[0] = 0.01;  r0[1] = 0;
	//---g`rf[]_C{wzCc{waCnf{̋ȐCemy̓_--------//
    rf[0] = r0[0];      rf[1] = r0[1];
	wa = 0.25;   	    wz = 0.5;
	//---U}`Frc[]_CwycCnvib}X̐Cyy2[0]U-------------------//
	rc[0] = -0.99;  rc[1] = 0;
	wy[0] = wa;     nvib = 1;
	//--- UȐ`Fr0[]_CwtԎCwy[]cCn{ȐCm̓_CUy[i][k]--//
	wt = 0.005; mm = 1.0/wt;  wy[0] = wa; wy[1] = wa;  ncurve = 2;

}

/************ dialogue() end ****************************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("Van der Poln̋U@m:nEO j: ύX, s:`p,@y,Y:fc{ύX t,T:ԎLk");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i, k;

	usrSetting();

	//-------- ̉ ------//
	for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
	    yy1[1] = yy2[1];
	    rkg1( t, dt, yy1, yy2, 2);
		t = t + dt;
	}

	//---U}`Fr0[]_CwycCn}X̐Cyy2[0]U-------------------//
	drawfigure(r0, wy[0], nvib, &yy2[0] );                          //}X̐U
	//-----------------O͂ŕ\ ----------------------------------------//
	arrowl = 0.3*sin(z*t)*wy[0];   alpha = PAI/2; arrowd = 0.03;
	if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	arrowl = fabs(arrowl);  
    arrow0[0] = r0[0] + 0.5*(xedge - r0[0]);       //̐[}X̏㉺0.2̈ʒu
	arrow0[1] = r0[1] + yy2[0]*wy[0] - arrowd;
	usrDrawArrow2d( arrow0, arrowl, alpha, green ); 
//	void usrDrawArrow2d( double r0[], double a, double alpha, GLfloat color[] )

	//--- Ȑ`  0:}X̐U@1:O ----------------------------------//
    drawcharacter(-0.95, 0.95, H18, "red   : response y(t)");
    drawcharacter(-0.95, 0.90, H18, "green : force f(t)/K");
    drawcharacter(-0.95, 0.85, H18, "1grid=(2s,0.2m)");
	//--- r0[]_CwtԎCwy[]cCn{ȐCm̓_CUy[i][k]--//
    //  	wt = 0.005; 	ncurve = 2;
	wy[0] = wa; wy[1] = wa;
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Force*sin(z*t);
	usrDrawAxis2d( rc, 0.0 );
	r1[0] = r0[0] - 60*wt/(nrkg*dt);  r1[1] = r0[1];
    usrGrating( r1, 0.0, 30, 2*wt/(nrkg*dt), 0.2*wa );
	drawcurven( rc, wt, wy, ncurve, m, yseries, MMAX );               //UȐ


	//---g`Frf[]_C{wzCc{waCnf{̋ȐCemy̓_--------//
	if(sgnf=='e')
	{
    drawcharacter(-0.1, -0.10, H18, "blue : epsilon={0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1,2,5,10}");
    drawcharacter(-0.1, -0.15, H18, "red  : given epsilon");
	for(k=0;k<nf;k++)
	drawFVanderPol(rf, wz, wa, my, aseries[k], blue ); 
	}
	if(sgnf=='E')
	{
    drawcharacter(-0.1, -0.10, H18, "blue : Force={0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1,2,5,10}");
    drawcharacter(-0.1, -0.15, H18, "red  : given Force");
	for(k=0;k<nf;k++)
	drawFVanderPol(rf, wz, wa, my, bseries[k], blue ); 
	}
    drawcharacter(-0.1, -0.20, H18, "black line : unstable under this line(=1.414)");
    drawcharacter(-0.1, -0.25, H18, "green line  : given z");
//  rf[0] = r0[0];      rf[1] = r0[1];
//	wa = 0.25;   	    wz = 0.25;
	r1[0] = rf[0] + wz;    r1[1] = rf[1];
	r2[0] = r1[0];         r2[1] = rf[1] + 5.0;
    usrDrawLine2d(r1, r2, blue );          //z=1(UU)c
	r1[0] = rf[0] + wz*z;  r1[1] = rf[1];
	r2[0] = r1[0];         r2[1] = rf[1] + 5.0;
    usrDrawLine2d(r1, r2, green );          //z(UĂU)c
	r1[0] = rf[0];         r1[1] = rf[1] + wa*ylimit;
	r2[0] = r1[0] + 5.0;   r2[1] = r1[1];
    usrDrawLine2d(r1, r2, black );            //ȉ͕s
	drawFVanderPol(rf, wz, wa, my, aseries0, red );
	for(k=0;k<IZ;k++)                        //w肵ẑƂ̐U\
	{   r1[0] = rf[0] + wz*z;    r1[1] = rf[1] + wa*YY[k];
		usrDrawSolidCircle2d(r1, 0.01, green );
	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/


/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	KEY = key;

	if(key=='s')       //U`p
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='y' || key=='Y')    //g̏c{
	{
		if(key=='y')  wa = 0.9*wa;
		if(key=='Y')  wa = wa/0.9;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')    //UȐԎLk
	{
		if(key=='t')  wt =  0.9*wt;
		if(key=='T')  wt = wt/0.9;
		mm = 1.0/wt;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='z' || key=='Z')    //gLk
	{
		if(key=='z')  wz =  0.9*wz;
		if(key=='Z')  wz = wz/0.9;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='e' || key=='E')    //gLk
	{
		sgnf = key;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='m' || key=='f' || key=='j')  //p[^EύX
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='\033')   exit(0);
	else              usrdisplay();

end:;
}

void motion_function(void){ }
